DEFINT A-Z
DECLARE FUNCTION GetLabelOffset& (labelname$)
DECLARE FUNCTION CalculateThis$ (orgtext$)
DECLARE FUNCTION ParseText2ndRound$ (orgtext$)
DECLARE FUNCTION ParseText$ (text$)
DECLARE FUNCTION GetRCPel% (txt$)
DECLARE FUNCTION ValidRSPReg$ (txt$)
DECLARE FUNCTION CalcEQU$ (xxx$)
DECLARE FUNCTION RemoveTrash$ (txt$)
DECLARE FUNCTION CountStr% (txx$, sort$)
DECLARE FUNCTION FixVal16$ (flump$)
DECLARE FUNCTION GetAdr& (tmp$)
DECLARE FUNCTION GetTrueVal32& (invar$)
DECLARE FUNCTION GetTrueVal16& (flump$)
DECLARE FUNCTION GetByteValue$ (txt$)
DECLARE FUNCTION GetVal16$ (flump$)
DECLARE FUNCTION GetVal32$ (invar$)
DECLARE FUNCTION CheckEQU$ (tsxx$)
DECLARE FUNCTION ValidCP2Reg$ (txt$)
DECLARE FUNCTION ValidFReg$ (txt$)
DECLARE FUNCTION GetDec& (tmp$)
DECLARE FUNCTION FromBin% (txt$)
DECLARE FUNCTION FromBin32& (txt$)
DECLARE FUNCTION ValidReg$ (txt$)
DECLARE FUNCTION GetValue16$ (tmp$)
DECLARE FUNCTION GetValue32$ (invar$)
DECLARE FUNCTION SHR# (var&, steps%)
DECLARE FUNCTION ToBin8$ (byte&)
DECLARE FUNCTION ToBin16$ (word&)
DECLARE FUNCTION ToBin32$ (word&)
DECLARE FUNCTION shl# (var&, steps%)
DECLARE FUNCTION GetBranchVal$ (num&)
DECLARE FUNCTION GetBranchValBREAK$ (num&)
DECLARE SUB DeterminateDBlength (itxt$)
DECLARE SUB DeterminateDWlength (itxt$)
DECLARE SUB DeterminateLIencoding (itxt$)
DECLARE SUB GenerateBinary ()
DECLARE SUB SetStartVars ()
DECLARE SUB ShowSyntax (txt$)
DECLARE SUB GetSyntax ()
DECLARE SUB HandleDirective ()
DECLARE SUB IncludeBin ()
DECLARE SUB InsertBlock ()
DECLARE SUB WordBlock ()
DECLARE SUB HalfBlock ()
DECLARE SUB ByteBlock ()
DECLARE SUB RSPType2 (xxx$)
DECLARE SUB RSPType1 (xxx$, xxx2$, shiftie%)
DECLARE SUB PseudoType6 ()
DECLARE SUB PseudoType5 (xxx$)
DECLARE SUB PseudoType4 (xxx$)
DECLARE SUB PseudoType3 (xxx$)
DECLARE SUB PseudoType2 (xxx$)
DECLARE SUB PseudoType1 (xxx$)
DECLARE SUB Type32 (xxx$)
DECLARE SUB Type31 (xxx$)
DECLARE SUB Type30 (xxx$)
DECLARE SUB Type29 (xxx$)
DECLARE SUB Type28 (xxx$)
DECLARE SUB Type27 (xxx$)
DECLARE SUB Type26 (xxx$)
DECLARE SUB Type24 (xxx$)
DECLARE SUB Type25 (xxx$)
DECLARE SUB Type23 (xxx$)
DECLARE SUB Type22 (xxx$)
DECLARE SUB Type21 (xxx$)
DECLARE SUB Type20 (xxx$)
DECLARE SUB Type19 (xxx$)
DECLARE SUB Type18 (xxx$)
DECLARE SUB Type17 (xxx$)
DECLARE SUB Type16 (xxx$)
DECLARE SUB Type15 (xxx$)
DECLARE SUB Type14 (xxx$)
DECLARE SUB Type13 (xxx$)
DECLARE SUB Type12 (xxx$)
DECLARE SUB Type11 (xxx$)
DECLARE SUB Type10 (xxx$)
DECLARE SUB Type9 (xxx$)
DECLARE SUB Type8 (xxx$)
DECLARE SUB Type7 (xxx$)
DECLARE SUB Type6 (xxx$)
DECLARE SUB Type5 (xxx$)
DECLARE SUB Type4 (xxx$)
DECLARE SUB Type3 (xxx$)
DECLARE SUB Type2 (xxx$)
DECLARE SUB Type1 (xxx$)
DECLARE SUB Type0 ()
DECLARE SUB SplitParam (some$, trams%)
DECLARE SUB ErrorCode (num%, txt$)

ON ERROR GOTO ErrorMessage

'
'dim statements
'
  DIM SHARED Version$
  DIM SHARED InFile$, TempFile$, TempFile2$, OutFile$, IncludeFile$, Syntax$, MacroFile$
  DIM SHARED LineCount&, IncludeCnt&           'hller koll p vilken rad man e p :)
  DIM SHARED BootCode1$
  DIM SHARED rad$, param$, inst$
  DIM SHARED ParamErr, known, UnknownInstr
  DIM SHARED Reg$(&H1F), Reg2$(&H1F), Reg3$(&H1F), Reg4$(&H1F)
  DIM SHARED FReg$(&H1F), FReg2$(&H1F), CP2Reg$(&H1F), CP2BReg$(&H1F), RSPReg$(&H1F)
  DIM SHARED MainCode&                        'points where i am in outfile
  DIM SHARED MBitVal, NoHeader
  DIM SHARED BadFlag                          '=1 om fel uppsttt vid kompilering
  DIM SHARED ErrCnt                           'error counter
  DIM SHARED UnSuppCnt, NonExistLabelCnt      'unsupported opcodes counter
  DIM SHARED BaseAdr&, BaseAdrValue$          'contains value of .base
  DIM SHARED ByteSwap, ByteRad$               '1=true
  DIM SHARED OkFileWrite                      '1 = rtt antal bytes skrivna
  DIM SHARED LabelPosCounter                  'vart i binaryn aktuell label finns
  DIM SHARED OpcodePosCnt                     'en till counter
  DIM SHARED LocalLabel&                      'fr local labels :-)

  DIM SHARED BootTitle$, BootManufact$, BootCartID$, BootCountry$, BootCode$
  DIM SHARED ErrorSpaces$, MaxErrors
  DIM SHARED CheckEQUTimes           'antal gnger man kr checkequ p varje rad
  DIM SHARED KeepFile, DebugMode, AlignSize
  DIM SHARED DirectJump              'tells that J & JAL is a direct adr jump.

  DIM SHARED leftfound, rightfound    'to be used with complex calculations only
  DIM SHARED Pass 'contains wich pass we're in (used for determinating if we should look up label offsets)


'Limitations:
'----------------
'Labels    : 1500
'EQU's     : 1500
'Macros    : 200
'Parameters: 6

  DIM SHARED Label$(1500), LabelCnt&          'labels
  DIM SHARED EQU$(1500), EQUCnt                'equ's
  DIM SHARED Parameter$(6), ParameterCNT      'parameters
  DIM SHARED IncludeBak$(20), IncBakCnt&      'max number of macros in a include
                          

'
'startup variabler
'
SetStartVars

  Syntax$ = COMMAND$
  'Syntax$ = "new_test.asm"

  TempFile$ = "N64ASM.TMP"
  TempFile2$ = "N64ASM.TM2"
  MacroFile$ = "N64ASM.MAC"

  '-----------------defaults----------------------------------
  ByteSwap = 0                'no byteswapping
  KeepFile = 0                'delete file if error occurs
  NoHeader = 1                'skip header generation
  MaxErrors = 100             '100 errors then stop
  CheckEQUTimes = 2           'check for equ 2 times/line only
  DebugMode = 0               '0 = release version, 1 = error debugging
  AlignSize = 4               '2,4 or 8

  ErrorSpaces$ = " "
  rad$ = ""

'
'program start
'
PRINT Version$
PRINT

   IF Syntax$ = "" THEN
      ShowSyntax ""
   END IF

   GetSyntax

   '
   PRINT " Reading and parsing '"; InFile$; "' ..."
   'plockar ven ut .noheader och .base direktiv och erstter EQU's med
   'respektive kod, kollar om man ska byteswappa  ordnar med include filer
   '
   
   IF InFile$ <> "" THEN
      ErrFile$ = InFile$
      OPEN ErrFile$ FOR BINARY AS #1
          IF LOF(1) = 0 THEN
             PRINT "  "; InFile$; " does not exist!"
             CLOSE #1
             KILL InFile$
             END
          END IF
      CLOSE #1
   ELSE
      ShowSyntax ""
   END IF

   ErrFile$ = TempFile2$
   OPEN ErrFile$ FOR BINARY AS #2: CLOSE #2
   KILL TempFile2$

   ErrFile$ = TempFile$
   OPEN ErrFile$ FOR BINARY AS #2: CLOSE #2
   KILL TempFile$

   ErrFile$ = MacroFile$
   OPEN ErrFile$ FOR BINARY AS #2: CLOSE #2
   KILL MacroFile$

  
   ErrFile$ = InFile$
   OPEN ErrFile$ FOR INPUT AS #1

   ErrFile$ = TempFile$
   OPEN ErrFile$ FOR OUTPUT AS #2


   Pass = 1

   DO WHILE NOT EOF(1)
      skipme = 0
      LINE INPUT #1, text$
      LineCount& = LineCount& + 1
      tmp1$ = LTRIM$(STR$(LineCount&))
      rad$ = tmp1$
      text$ = LTRIM$(RTRIM$(text$))
      textT$ = "": textR$ = ""
      temp = INSTR(text$, ";")
      IF temp THEN text$ = RTRIM$(LEFT$(text$, temp - 1))
      IF text$ <> "" THEN
         text$ = RemoveTrash(text$)
         IF text$ <> "" THEN
            search = INSTR(text$, ":")
            searchB = INSTR(text$ + " ", " ")
            IF search > 0 AND searchB > search THEN
               labeln$ = LEFT$(text$, search)
               'hittar en label i brjan av raden, plockar ut  skriver
               text2$ = LTRIM$(RTRIM$(MID$(text$, search + 1)))

               FOR koko& = 0 TO LabelCnt&
                   klls$ = Label$(koko&)
                   klla = INSTR(klls$, " ")
                   kllk$ = RTRIM$(MID$(klls$, 1, klla))
                   IF kllk$ = labeln$ THEN
                      kllk2$ = LEFT$(kllk$, LEN(kllk$) - 1)  ' tar bort : tecken
                      ErrorCode 15, kllk2$
                   END IF
               NEXT koko&

               Label$(LabelCnt&) = labeln$ + STR$(LabelPosCounter)
               LabelCnt& = LabelCnt& + 1
               IF text2$ <> "" THEN  'skriver ev koder efter label:
                  'check if there is special crap here:

                  slurkskurk = INSTR(text2$, " ")
                  slurk$ = RTRIM$(MID$(text2$, 1, slurkskurk))

                  SELECT CASE UCASE$(slurk$)
                     CASE "LI":  DeterminateLIencoding text2$
                     CASE "DB":  DeterminateDBlength text2$
                     CASE "DW":  DeterminateDWlength text2$
                     CASE ELSE: PRINT slurk$; " - kaoo1 :)"
                  END SELECT

                  LabelPosCounter = LabelPosCounter + 1
                  PRINT #2, tmp1$ + " " + text2$
               END IF
               skipme = 1
            END IF

            text$ = LTRIM$(RTRIM$(text$))
            flsk = INSTR(text$, " ")
            IF flsk > 0 THEN
               textT$ = LEFT$(text$, flsk - 1)
               textR$ = LTRIM$(MID$(text$, flsk + 1))
               FOR kaka = 1 TO CheckEQUTimes
                   textR$ = CheckEQU(textR$)
               NEXT kaka
               textR$ = CalcEQU(textR$)
            ELSE
               textT$ = text$
            END IF
            SELECT CASE UCASE$(textT$)
                CASE ".BYTESWAP":
                   ByteRad$ = LTRIM$(STR$(LineCount&))
                   ByteSwap = -1: skipme = 1
                   textR$ = UCASE$(textR$)
                   SELECT CASE textR$
                      CASE "YES", "ON", "TRUE": ByteSwap = 1
                      CASE "NO", "OFF", "FALSE": ByteSwap = 0
                   END SELECT
                CASE ".NOCHANGEBYTES":
                   ByteSwap = 0: skipme = 1
                CASE ".CHANGEBYTES":
                   ByteSwap = 1: skipme = 1
                CASE ".BASE":
                   BaseAdr& = GetDec(textR$): skipme = 1
                   BaseAdrValue$ = GetVal32(textR$)
                CASE "INCLUDE", ".INCLUDE": 'there are a file to include here..
                   skipme = 1: tramsa$ = LTRIM$(RTRIM$(textR$))
                   IF LEFT$(tramsa$, 1) = CHR$(34) THEN    'text strng
                      IF RIGHT$(tramsa$, 1) = CHR$(34) THEN    'text strng
                         tmp1 = LEN(tramsa$)
                         IncludeFile$ = UCASE$(MID$(tramsa$, 2, tmp1 - 2))
                      ELSE
                         PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
                      END IF
                   ELSE
                      IncludeFile$ = UCASE$(tramsa$)
                   END IF
                   'IncludeFile$ innehller nu filnamnet p includefilen
                   ErrFile$ = IncludeFile$
                   OPEN ErrFile$ FOR BINARY AS #5
                       skabb# = LOF(5)
                   CLOSE #5
                   IF skabb# = 0 THEN   'filen finns inte
                      rad$ = LTRIM$(STR$(LineCount&))
                      ErrorCode 10, IncludeFile$
                      IF DebugMode = 0 THEN KILL IncludeFile$
                   ELSE
                      PRINT "  Including '"; IncludeFile$; "' ... ";
                      IncBakCnt& = 0
                      ErrFile$ = IncludeFile$
                      OPEN ErrFile$ FOR INPUT AS #5
                         IncludeCnt& = 0
                         DO
                            LINE INPUT #5, krass$: IncludeCnt& = IncludeCnt& + 1: skipme2 = 0
                            temp = INSTR(krass$, ";")
                            IF temp THEN krass$ = RTRIM$(LEFT$(krass$, temp - 1))
                            krass$ = LTRIM$(RTRIM$(krass$))

                            temp = INSTR(krass$, " ")
                            IF temp THEN
                               txtXX$ = LEFT$(krass$, temp - 1)
                               txtYY$ = LTRIM$(MID$(krass$, temp + 1))
                            END IF
                            IF txtXX$ <> "" THEN    'kollar om det r en EQU
                               IF LEFT$(txtYY$, 4) = "EQU " THEN 'hittad
                                  equname$ = txtXX$
                                  equvalue$ = MID$(txtYY$, 5): skipme2 = 1
                                  FOR kaka = 1 TO CheckEQUTimes
                                      equvalue$ = CheckEQU(equvalue$) 'erstter andra equ's
                                  NEXT kaka
                                  equvalue$ = CalcEQU(equvalue$)
                                  IF equvalue$ <> "" THEN
                                     EQU$(EQUCnt) = UCASE$(equname$) + " " + equvalue$
                                     EQUCnt = EQUCnt + 1
                                  END IF
                               END IF
                            END IF
                            '--------
                            'ska kolla macro hr

                            '------------- kollar efter en label
                            search = INSTR(krass$, ":")
                            searchB = INSTR(krass$ + " ", " ")
                            
                            IF search > 0 AND searchB > search THEN
                               labeln$ = LEFT$(krass$, search)
                               'hittar en label i brjan av raden, plockar ut  skriver
                               krass2$ = LTRIM$(RTRIM$(MID$(krass$, search + 1)))

                               FOR koko& = 0 TO LabelCnt&
                                   klls$ = Label$(koko&)
                                   klla = INSTR(klls$, " ")
                                   kllk$ = RTRIM$(MID$(klls$, 1, klla))
                                   IF kllk$ = labeln$ THEN
                                      kllk2$ = LEFT$(kllk$, LEN(kllk$) - 1)  ' tar bort : tecken
                                      ErrorCode 15, kllk2$
                                   END IF
                               NEXT koko&

                               Label$(LabelCnt&) = labeln$ + STR$(LabelPosCounter)
                               LabelCnt& = LabelCnt& + 1
                               IF krass2$ <> "" THEN  'skriver ev koder efter label:

                                  'check if there is special crap here:

                                  slurkskurk = INSTR(krass2$, " ")
                                  slurk$ = RTRIM$(MID$(krass2$, 1, slurkskurk))
                  
                                  SELECT CASE UCASE$(slurk$)
                                     CASE "LI":  DeterminateLIencoding krass2$
                                     CASE "DB":  DeterminateDBlength krass2$
                                     CASE "DW":  DeterminateDWlength krass2$
                                     CASE ELSE: PRINT slurk$; " - kaoo2 :)"
                                  END SELECT


                                  LabelPosCounter = LabelPosCounter + 1
                                  PRINT #2, LTRIM$(STR$(IncludeCnt&)); "_"; IncludeFile$; " "; krass2$
                               END IF
                               skipme2 = 1
                            END IF

                            '---------
                            IF krass$ <> "" THEN  'om det r nn kod kvar
                               'skriver hela includefilen till .tmp filen
                               IF skipme2 = 0 THEN
                                  FOR kaka = 1 TO CheckEQUTimes
                                      krass$ = CheckEQU(krass$)
                                  NEXT kaka
                                  krass$ = CalcEQU(krass$)

                                  'check if there is special crap here:

                                  slurkskurk = INSTR(krass$, " ")
                                  slurk$ = RTRIM$(MID$(krass$, 1, slurkskurk))

                                  SELECT CASE UCASE$(slurk$)
                                     CASE "LI":  DeterminateLIencoding krass$
                                     CASE "DB":  DeterminateDBlength krass$
                                     CASE "DW":  DeterminateDWlength krass$
                                     CASE ELSE: PRINT slurk$; " - kaoo3 :)"
                                  END SELECT

                                  LabelPosCounter = LabelPosCounter + 1
                                  PRINT #2, LTRIM$(STR$(IncludeCnt&)); "_"; IncludeFile$; " "; krass$
                               END IF
                            END IF
                         LOOP WHILE NOT EOF(5)
                      CLOSE #5
                      PRINT "Done."
                      FOR tmp& = 1 TO IncBakCnt&
                          PRINT IncludeBak$(tmp&)
                      NEXT tmp&
                   END IF
                CASE ".TITLE", ".ROMNAME":
                   BootTitle$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".MANUFACTURER":
                   BootManufact$ = GetVal16(textR$): skipme = 1: NoHeader = 0
                   BootManufact$ = RIGHT$(BootManufact$, 1)  'tar lga byten bara
                CASE ".CARTID", ".ROMID":
                   BootCartID$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".COUNTRY", ".ROMCOUNTRY":
                   BootCountry$ = GetVal16(textR$): skipme = 1: NoHeader = 0
                   BootCountry$ = RIGHT$(BootCountry$, 1)  'tar lga byten bara
                CASE ".BOOTCODE":
                   BootCode$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".MBIT":
                   MBitVal = GetDec(textR$): skipme = 1
                CASE ".NOHEADER":
                   skipme = 1: NoHeader = 1
                CASE ".HEADER":
                   skipme = 1: NoHeader = 0
                CASE ".V64HEADER":
                   skipme = 1: NoHeader = 0
                CASE ".ALIGN2":
                   skipme = 1: AlignSize = 2
                CASE ".ALIGN4":
                   skipme = 1: AlignSize = 4
                CASE ".ALIGN8":
                   skipme = 1: AlignSize = 8
                CASE ".ALIGN":
                   skipme = 1
                   SELECT CASE textR$
                      CASE "2", "4", "8": AlignSize = GetDec(textR$)
                      CASE ELSE: ErrorCode 14, textR$
                   END SELECT
            END SELECT
            
            IF textT$ <> "" THEN    'kollar om det r en EQU
               trump$ = UCASE$(LEFT$(textR$, 3))
               IF trump$ = "EQU" THEN  'hittad
                   equname$ = textT$: equvalue$ = LTRIM$(MID$(textR$, 5)): skipme = 1
                   
                   'erstter andra EQU's i denna EQU med resp. kod
                   FOR kaka = 1 TO CheckEQUTimes
                       equvalue$ = CheckEQU(equvalue$)
                   NEXT kaka
                   equvalue$ = CalcEQU(equvalue$)
                   
                   IF equvalue$ <> "" THEN
                      EQU$(EQUCnt) = UCASE$(equname$) + " " + equvalue$
                      EQUCnt = EQUCnt + 1
                   END IF
               END IF
            END IF

            '----------
            'macro ska va hr
            '----------


            
            IF skipme = 0 THEN  'kolla hr om ngon definierad EQU finns i raden  erstt
               FOR kaka = 1 TO CheckEQUTimes
                   text$ = CheckEQU(text$)
               NEXT kaka
               text$ = CalcEQU(text$)
               IF LEFT$(text$, 1) <> "." THEN LabelPosCounter = LabelPosCounter + 1


                  'check if there is special crap here:

                  slurkskurk = INSTR(text$, " ")
                  slurk$ = RTRIM$(MID$(text$, 1, slurkskurk))

                  SELECT CASE UCASE$(slurk$)
                     CASE "LI":  DeterminateLIencoding text$
                     CASE "DB":  DeterminateDBlength text$
                     CASE "DW":  DeterminateDWlength text$

                     'CASE ELSE: PRINT slurk$; " - kaoo4 :)"
                  END SELECT

               PRINT #2, tmp1$ + " " + text$
            END IF

         END IF
      END IF
   LOOP
   CLOSE #1, #2

IF BaseAdr& = 0 THEN BaseAdr& = &H80200000

IF ByteSwap = -1 THEN
   rad$ = ByteRad$
   ErrorCode 7, tempo$
END IF

IF ByteSwap = 0 THEN OutFile$ = OutFile$ + ".BIN"
IF ByteSwap = 1 THEN OutFile$ = OutFile$ + ".V64"



'
PRINT ErrorSpaces$; " Reading and parsing is done, generating binary .."
ErrorSpaces$ = "    "
'
Pass = 2
GenerateBinary

'
'lgger till 1 till 3 nollor p slutet fr att filstorleken
'ska kunna delas jmt med 2,4 eller 8.

ErrFile$ = TempFile2$
OPEN ErrFile$ FOR BINARY AS #2
   OutLen# = LOF(2)
CLOSE #2

tmp1# = OutLen# / AlignSize  ' 2,4 eller 8
tmp2# = INT(tmp1# + .5)
NewOutLen# = OutLen#

IF tmp1# <> tmp2# THEN
   'mste lgga till nollor
   DO
     NewOutLen# = NewOutLen# + 1
     tmp1# = NewOutLen# / AlignSize  '2,4 eller 8
     tmp2# = INT(tmp1# + .5)
     IF tmp1# = tmp2# THEN
        EXIT DO
     END IF
   LOOP
   AddOutLen# = NewOutLen# - OutLen#
   addcode$ = STRING$(AddOutLen#, CHR$(0))
   ErrFile$ = TempFile2$
   OPEN ErrFile$ FOR BINARY AS #2
      PUT #2, MainCode&, addcode$
   CLOSE #2
END IF





'
ErrFile$ = TempFile2$
OPEN ErrFile$ FOR BINARY AS #2
   OutLen# = LOF(2)
CLOSE #2
PRINT ErrorSpaces$; " Generated '"; OutFile$; "' ("; LTRIM$(STR$(OutLen#)); " bytes) "   '; ","; LabelPosCounter; "opcode(s)"


Pass = 3
'
'byteswap image
ErrorSpaces$ = "       "
'
IF ByteSwap = 1 THEN
   PRINT ErrorSpaces$; " Byteswapping .. ";
   ErrFile$ = TempFile2$
   OPEN ErrFile$ FOR BINARY AS #2   'orginalfil
   ErrFile$ = OutFile$
   OPEN ErrFile$ FOR BINARY AS #3
       dword$ = "    "
       DO
          GET #2, , dword$
          IF EOF(2) THEN EXIT DO
          vmput$ = ""
          FOR ttx = 1 TO 4 STEP 2
              vmp1$ = MID$(dword$, ttx, 1)
              vmp2$ = MID$(dword$, ttx + 1, 1)
              vmput$ = vmput$ + vmp2$ + vmp1$
          NEXT
          PUT #3, , vmput$
       LOOP
   CLOSE #2, #3

   IF DebugMode = 0 THEN KILL TempFile2$

   PRINT "Done."
END IF

'
'Fix megabit size, adda 00h till korrekt storlek
'
    MBitSize& = MBitVal
    IF MBitSize& > 0 THEN
       bytesize# = ((MBitSize& * 1024) * 1024) / 8
       PRINT ErrorSpaces$; " Fixing file lenght to"; bytesize#; "bytes ("; LTRIM$(STR$(MBitVal)); " MBit) .. ";
       ErrFile$ = OutFile$
       OPEN ErrFile$ FOR BINARY AS #2
       RestCode& = MainCode&
       DO
          towrite# = bytesize# - RestCode&
          IF towrite# > 7000 THEN
             tmp$ = STRING$(7000, CHR$(0))
             PUT #2, RestCode&, tmp$
             RestCode& = RestCode& + 7000
          ELSE
             tmp$ = STRING$(towrite# + 1, CHR$(0))
             PUT #2, RestCode&, tmp$
             endvillkor = 1
          END IF
       LOOP UNTIL endvillkor = 1
       CLOSE #2
       PRINT "Done."
    END IF
'


IF NonExistLabelCnt + UnknownInstr > 0 THEN 'visar om det blev ntt fel
   PRINT ErrorSpaces$; " Found"; NonExistLabelCnt; "non-existing label(s) and"; UnknownInstr; "unknown instruction(s)"
END IF

IF UnSuppCnt > 0 THEN PRINT " Found"; UnSuppCnt; "unsupported opcode(s)"

IF BadFlag = 1 THEN
   IF KeepFile = 0 THEN
      PRINT ErrorSpaces$; " Binary has errors, deleting it."
      IF DebugMode = 0 THEN
         OPEN TempFile2$ FOR BINARY AS #2   'make sure it exists
         CLOSE #2
         KILL TempFile2$

         OPEN OutFile$ FOR BINARY AS #2   'make sure it exists
         CLOSE #2
         KILL OutFile$
      END IF
   END IF
   PRINT ErrorSpaces$; " There occured"; ErrCnt; "error(s)"

ELSE
   PRINT ErrorSpaces$; " Outfile generated, don't forget to calculate the CRC."

   'you could run a external CRC calculation program here, like this:
   'SHELL "calccrc " + OutFile$

END IF


IF DebugMode = 0 THEN
   KILL TempFile$
   IF MacroCount& > 0 THEN KILL MacroFile$
END IF

END







ErrorMessage:
    PRINT ErrorSpaces$; " DOS error "; LTRIM$(STR$(ERR)); ": ";
    SELECT CASE ERR
        CASE 6: PRINT "Overflow."
        CASE 14: PRINT "Out of string space."
        CASE 63: PRINT "Bad record number."
        CASE 64: PRINT ErrFile$; " is a bad filename."
        CASE 70: PRINT ErrFile$; " is used by another program."
        CASE 75: PRINT ErrFile$; " cannot be deleted (path/file access error)."
        CASE 76: PRINT "Path '"; ErrFile$; "' not found."
        CASE ELSE: PRINT "Unknown error."
    END SELECT

    CLOSE

END

SUB ByteBlock

    known = 1
    ByteText$ = GetByteValue(param$)

    ByteTxtLen = LEN(ByteText$)
    
    cptest = 0

    DO
       IF ByteTxtLen > cptest THEN
          cptest = cptest + 4
       ELSE
          EXIT DO
       END IF
       

       IF cptest >= 8192 THEN   'just a maximum length for a byte string.
          PRINT "Error!! Too long fucking byte string!! it must not be over"; cptest&; "bytes."
          EXIT DO
       END IF
    LOOP

    'count how many 0x00 we should insert.
    gargamelformel = cptest - ByteTxtLen
    gargameltrolleri$ = STRING$(gargamelformel, 0)
    ByteText$ = ByteText$ + gargameltrolleri$

    PUT #2, MainCode&, ByteText$
    MainCode& = MainCode& + cptest

END SUB

FUNCTION CalcEQU$ (xxx$)
   
    'kollar om det r en EQU med en kalkulation, och rknar ut den:
    IF UCASE$(LEFT$(xxx$, 4)) = "EQU " THEN
       xx2$ = LTRIM$(MID$(xxx$, 4))
       temp$ = GetValue32(xx2$)
       IF temp$ <> "" THEN
          CalcEQU = "EQU " + temp$
       ELSE
          CalcEQU = xxx$
       END IF
    ELSE
       CalcEQU = xxx$
    END IF

END FUNCTION

DEFSNG A-Z
FUNCTION CalculateThis$ (orgtext$)

DO
   crap$ = ParseText(orgtext$)

   IF crap$ = orgtext$ THEN EXIT DO
   orgtext$ = crap$
LOOP

'snyggar till paranteserna
FOR a = 1 TO LEN(orgtext$)
    kaka$ = MID$(orgtext$, a, 1)
    IF kaka$ = "`" THEN kaka$ = "(": firstpar = firstpar + 1
    IF kaka$ = "'" THEN kaka$ = ")": lastpar = lastpar + 1
    owt$ = owt$ + kaka$
NEXT a
orgtext$ = owt$

IF firstpar = 1 AND lastpar = 1 THEN
   firstie = INSTR(orgtext$, "(")
   lastie = INSTR(orgtext$, ")")
   beforethis$ = MID$(orgtext$, 1, firstie - 1)
   calcthis$ = MID$(orgtext$, firstie + 1, lastie - firstie - 1)
   afterthis$ = MID$(orgtext$, lastie + 1)

   finishthis$ = ParseText2ndRound(calcthis$)
   orgtext$ = beforethis$ + finishthis$ + afterthis$
ELSE
   IF firstpar > 1 OR lastpar > 1 THEN
      PRINT "Error somewhere '"; orgtext$; "'"
   END IF
END IF



'orgtext$ contains what to start with now in the 2:nd round

Finished$ = ParseText2ndRound(orgtext$)

CalculateThis$ = Finished$

END FUNCTION

DEFINT A-Z
FUNCTION CheckEQU$ (tsxx$)

    tsxx2$ = tsxx$
    FOR a = 0 TO EQUCnt - 1
        kmp1 = INSTR(EQU$(a), " ")
        kmpname$ = LEFT$(EQU$(a), kmp1 - 1)
        kmpvalue$ = MID$(EQU$(a), kmp1 + 1)
        kmp2 = INSTR(UCASE$(tsxx$), kmpname$)
        IF kmp2 > 0 THEN  'hittade en rad med EQU grejs i
           'kolla tecknet innan och efter EQU'n fr att frskra oss
           'om att det r en kta equ och inte en del av en annan
           'strng eller ngot i den stilen.
           IF kmp2 > 1 THEN
              DelInnan2$ = UCASE$(MID$(tsxx$, kmp2 - 1, 1))
              DelInnan = ASC(DelInnan2$)
           ELSE
              DelInnan = 0
           END IF
          
           DelEfter2$ = UCASE$(MID$(tsxx$, kmp2 + LEN(kmpname$), 1))
           IF DelEfter2$ <> "" THEN
              DelEfter = ASC(DelEfter2$)
           ELSE
              DelEfter = 0
           END IF
          
           ItIsWrong1 = 0 'fr vara vadsomhelst utan siffra och boxtav
           IF DelInnan > 47 AND DelInnan < 58 THEN ItIsWrong1 = 1  '0-9
           IF DelInnan > 64 AND DelInnan < 91 THEN ItIsWrong1 = 1  'A-Z
           IF DelInnan > 96 AND DelInnan < 123 THEN ItIsWrong1 = 1 'a-z

           ItIsWrong2 = 0
           IF DelEfter > 47 AND DelInnan < 58 THEN ItIsWrong2 = 1  '0-9
           IF DelEfter > 64 AND DelInnan < 91 THEN ItIsWrong2 = 1  'A-Z
           IF DelEfter > 96 AND DelInnan < 123 THEN ItIsWrong2 = 1 'a-z
           
           IF ItIsWrong1 + ItIsWrong2 = 0 THEN  'om det inte e fel
              kmplen = LEN(kmpname$)
              tsxx2$ = LEFT$(tsxx$, kmp2 - 1) + kmpvalue$ + MID$(tsxx$, kmp2 + kmplen)
              tsxx$ = tsxx2$
           END IF

        END IF
    NEXT a

    CheckEQU = tsxx$
   
END FUNCTION

FUNCTION CountStr (txx$, sort$)

   'counts how many times sort$ is
   'in the string txx$

   fvnt = 0
   FOR vra = 1 TO LEN(txx$)
      klet$ = MID$(txx$, vra, 1)
      IF klet$ = sort$ THEN fvnt = fvnt + 1
   NEXT vra
   CountStr = fvnt

END FUNCTION

SUB DeterminateDBlength (itxt$)


    
    spccpslusk = INSTR(itxt$, " ")
    param$ = LTRIM$(MID$(itxt$, spccpslusk))
    

    ByteText$ = GetByteValue(param$)
    ByteTxtLen = LEN(ByteText$)
    cptest = 0

    DO
       IF ByteTxtLen > cptest THEN
          cptest = cptest + 4
       ELSE
          EXIT DO
       END IF


       IF cptest >= 8192 THEN   'just a maximum length for a byte string.
          PRINT "Error!! Too long fucking byte string!! it must not be over"; cptest&; "bytes."
          EXIT DO
       END IF
    LOOP

    'count how many 0x00 we should insert.
    LabelPosCounter = LabelPosCounter + (cptest / 4) - 1
    
END SUB

SUB DeterminateDWlength (itxt$)
    

    itxt2$ = LTRIM$(MID$(itxt$, 4))
    
    krosspunk = 0

    FOR varjostlask = 1 TO LEN(itxt2$)
        krasbultos$ = MID$(itxt2$, varjostlask, 1)
        IF krasbultos$ = "," THEN
           krosspunk = krosspunk + 1
        END IF
    NEXT

    LabelPosCounter = LabelPosCounter + krosspunk

END SUB

SUB DeterminateLIencoding (itxt$)

    itxt2$ = LTRIM$(MID$(itxt$, 4))
    tmpVeg = INSTR(itxt2$, ",")          'find the ,

    'if tmpveg = 0 then it will produce a error later on,
    'so why care about that for now? ;-)
    IF tmpVeg > 0 THEN
    '   itxt3$ = MID$(itxt2$, tmpVeg + 1)   'the value !!
    '
    '   thistmp$ = RIGHT$("00000000" + HEX$(VAL(GetValue32(itxt3$))), 8)
    '
    '   low16$ = "0x" + RIGHT$(thistmp$, 4)
    '   hi16$ = "0x" + LEFT$(thistmp$, 4)
    '   IF hi16$ <> "0x0000" THEN
    '      'YEAH!! it will be 2 instructions encoded later on :)
    '      LabelPosCounter = LabelPosCounter + 1   'so i count one extra
    '   END IF


        'optimization removed, this is the workaround.
        'll LI's will be 2 dwords.
        LabelPosCounter = LabelPosCounter + 1

    END IF


END SUB

SUB ErrorCode (num, txt$)
   
    BadFlag = 1
    ErrCnt = ErrCnt + 1
    IF ErrCnt > MaxErrors THEN
       CLOSE #1, #2
       IF DebugMode = 0 THEN KILL TempFile2$
       IF DebugMode = 0 THEN KILL TempFile$
       PRINT ErrorSpaces$; " Over"; MaxErrors; "errors occured, aborted assembling."
       END
    END IF

    ErrorFile$ = InFile$
    ErrorRad$ = rad$
    stkmp = INSTR(ErrorRad$, "_")
    IF stkmp THEN   'identifierar att det e en INCLUDE fil
       ErrorFile$ = MID$(ErrorRad$, stkmp + 1)
       ErrorRad$ = LEFT$(ErrorRad$, stkmp - 1)
    END IF

    ErrorFile$ = LCASE$(ErrorFile$)    'sm boxtver mkt snyggare
    
    
    IF ErrorRad$ = "" THEN
       PRINT ErrorSpaces$; " error"; STR$(num); ": ";
    ELSE
       PRINT ErrorSpaces$; " "; ErrorFile$; "("; ErrorRad$; ") error"; STR$(num); ": ";
    END IF
    SELECT CASE num
       CASE 1:  PRINT "Unknown register '"; txt$; "'"
       CASE 2:  PRINT "Unknown instruction '"; txt$; "'"
       CASE 3:  PRINT "Non-existing label '"; txt$; "'": NonExistLabelCnt = NonExistLabelCnt + 1
       CASE 4:  PRINT "Unsupported opcode '"; inst$; "'": UnSuppCnt = UnSuppCnt + 1
       CASE 5:  PRINT inst$; ": Too many parameters ("; txt$; ")"
       CASE 6:  PRINT inst$; ": Too few parameters ("; txt$; ")"
       CASE 7:  PRINT "Invalid parameter '"; txt$; "'"
       CASE 8:  PRINT "Unknown variable '"; txt$; "'"
       CASE 9:  PRINT "Overflow ("; txt$; " is too big)"
       CASE 10: PRINT "Includefile "; txt$; " does not exist."
       CASE 11: PRINT "Can't handle complex calculation '"; txt$; "'"
       CASE 12: PRINT "OPT directives support not implemented '"; param$; "'"
       CASE 13: PRINT "Direct values isn't supported yet."
       CASE 14: PRINT "Align size "; txt$; " is wrong, only 2,4 and 8 are valid."
       CASE 15: PRINT "Label '"; txt$; "' is already defined."
       CASE 16: PRINT "'"; txt$; "' is not allowed as delay slot."
       CASE ELSE: PRINT "Unknown error."
    END SELECT

END SUB

DEFSNG A-Z
FUNCTION FixVal16$ (flump$)
         
     knas$ = GetValue16(flump$)
     knas$ = HEX$(VAL(knas$))
    
     knorr& = VAL("&h" + knas$)
    
     knas$ = "0000" + knas$
     knas$ = RIGHT$(knas$, 4)
     FOR a = 1 TO LEN(knas$) STEP 2
         del = VAL("&h" + MID$(knas$, a, 2))
         temp$ = temp$ + CHR$(del)
     NEXT a
     FixVal16$ = temp$

END FUNCTION

DEFINT A-Z
FUNCTION FromBin (txt$)
  
   dum = 1: svar = 0
   FOR cca = LEN(txt$) TO 1 STEP -1
       tmp$ = MID$(txt$, cca, 1)
       IF tmp$ = "1" THEN svar = svar + dum
       dum = dum * 2
   NEXT
   FromBin = svar

END FUNCTION

FUNCTION FromBin32& (txt$)
  
   dum# = 1: svar& = 0
   FOR cca = LEN(txt$) TO 1 STEP -1
       tmp$ = MID$(txt$, cca, 1)
       IF tmp$ = "1" THEN svar& = svar& + dum#
       dum# = dum# * 2
   NEXT
   FromBin32& = svar&

END FUNCTION

SUB GenerateBinary
   
    IF ByteSwap = 0 THEN TempFile2$ = OutFile$
    ErrFile$ = TempFile2$
    OPEN ErrFile$ FOR BINARY AS #2: CLOSE #2
    IF DebugMode = 0 THEN KILL TempFile2$
  
    ErrFile$ = TempFile$
    OPEN ErrFile$ FOR INPUT AS #1
    ErrFile$ = TempFile2$
    OPEN ErrFile$ FOR BINARY AS #2
         IF NoHeader = 0 THEN
            temp$ = CHR$(&H80) + CHR$(&H37) + CHR$(&H12) + CHR$(&H40)
            temp$ = temp$ + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(&HF)
            temp$ = temp$ + CHR$(&H80) + CHR$(&H20) + CHR$(0) + CHR$(0)
            temp$ = temp$ + CHR$(0) + CHR$(0) + CHR$(&H14) + STRING$(&HFF1, 0)
            PUT #2, &H1, temp$
            MainCode& = &H1001
            IF BaseAdrValue$ <> "" THEN PUT #2, &H9, BaseAdrValue$
          
            IF BootTitle$ <> "" THEN PUT #2, &H20 + 1, BootTitle$
            IF BootManufact$ <> "" THEN PUT #2, &H3B + 1, BootManufact$
            IF BootCartID$ <> "" THEN PUT #2, &H3C + 1, BootCartID$
            IF BootCountry$ <> "" THEN PUT #2, &H3E + 1, BootCountry$
            IF BootCode$ <> "" THEN
               PRINT ErrorSpaces$; " Using boot code in '"; UCASE$(BootCode$); "'."
               ErrFile$ = BootCode$
               OPEN ErrFile$ FOR BINARY AS #4
               nytmp = LOF(4)
               IF nytmp = 0 THEN
                  PRINT " ("; rad$; ") File "; param$; " is missing."
                  CLOSE #4
                  IF DebugMode = 0 THEN
                     OPEN temp$ FOR BINARY AS #4  'make sure it exists
                     CLOSE #4
                     KILL temp$
                  END IF
               ELSE
                 IF nytmp <> 4032 THEN
                    PRINT " ("; rad$; ") File "; param$; " is not a valid ROM header."
                 ELSE
                    fintemp$ = STRING$(4032, 0)
                    GET #4, 1, fintemp$: PUT #2, &H41, fintemp$
                 END IF
                 CLOSE #4
              END IF
            END IF
         ELSE
            MainCode& = &H1
         END IF


         DO
            known = 0
            OpcodePosCnt = OpcodePosCnt + 1
            IF EOF(1) THEN EXIT DO
            LINE INPUT #1, text$
            tmp = INSTR(text$, " ")
            code$ = LTRIM$(MID$(text$, tmp + 1)) + " "
            rad$ = LEFT$(text$, tmp - 1)                  'rad-nummer
            tmp = INSTR(code$, " ")
            inst$ = LTRIM$(UCASE$(LEFT$(code$, tmp - 1))) 'instruktion
            param$ = LTRIM$(RTRIM$(MID$(code$, tmp + 1)))         'parametrar
            
            IF lastinstructionwasalabelorbranch = 1 THEN
               SELECT CASE inst$
                  CASE "LI", "LA", "J", "JAL", "BEQ", "BNE", "BLEZ", "BGTZ", "BEQL", "BNEL", "BLEZL", "BGTZL", "JR", "JALR", "BLTZ", "BGEZ", "BLTZL", "BGEZL", "BLTZAL", "BGEZAL", "BLTZALL", "BGEZALL", "BC0F", "BC0FL", "BC0T", "BC0TL", "BC1F",  _
"BC1FL", "BC1T", "BC1TL", "BC2F", "BC2FL", "BC2T", "BC2TL", "BNEZ", "BEQZ", "BNEZL", "B", "BAL":
                     ErrorCode 16, inst$
               END SELECT
               lastinstructionwasalabelorbranch = 0
            END IF
            
            IF DebugMode = 1 THEN
               PRINT code$; ": ", HEX$(MainCode& - 1)
               SLEEP
               DO
                 slasktras$ = INKEY$
                 IF UCASE$(slasktras$) = "Q" THEN END
                 IF slasktras$ = CHR$(13) THEN EXIT DO
               LOOP
            END IF

               'opcode
               SELECT CASE inst$
                  CASE "ADDI":   Type1 "001000"
                  CASE "ADDIU":  Type1 "001001"
                  CASE "SLTI":   Type1 "001010"
                  CASE "SLTIU":  Type1 "001011"
                  CASE "ANDI":   Type1 "001100"
                  CASE "ORI":    Type1 "001101"
                  CASE "XORI":   Type1 "001110"
                  CASE "DADDI":  Type1 "011000"
                  CASE "DADDIU": Type1 "011001"
                  CASE "LDL":    Type1 "011010"
                  CASE "LDR":    Type1 "011011"
                  CASE "LB":     Type1 "100000"
                  CASE "LH":     Type1 "100001"
                  CASE "LWL":    Type1 "100010"
                  CASE "LW":     Type1 "100011"
                  CASE "LBU":    Type1 "100100"
                  CASE "LHU":    Type1 "100101"
                  CASE "LWR":    Type1 "100110"
                  CASE "LWU":    Type1 "100111"
                  CASE "SB":     Type1 "101000"
                  CASE "SH":     Type1 "101001"
                  CASE "SWL":    Type1 "101010"
                  CASE "SW":     Type1 "101011"
                  CASE "SDL":    Type1 "101100"
                  CASE "SDR":    Type1 "101101"
                  CASE "SWR":    Type1 "101110"
                  CASE "CACHE":  Type1 "101111"
                  CASE "LL":     Type1 "110000"
                  CASE "PREF":   Type1 "110011"
                  CASE "LLD":    Type1 "110100"
                  CASE "LD":     Type1 "110111"
                  CASE "SC":     Type1 "111000"
                  CASE "SCD":    Type1 "111100"
                  CASE "SD":     Type1 "111111"
                  CASE "LUI":    Type2 "001111"
                
                  CASE "J":      Type8 "000010": lastinstructionwasalabelorbranch = 1
                  CASE "JAL":    Type8 "000011": lastinstructionwasalabelorbranch = 1
                  
                  CASE "BEQ":    Type10 "000100": lastinstructionwasalabelorbranch = 1
                  CASE "BNE":    Type10 "000101": lastinstructionwasalabelorbranch = 1
                  CASE "BLEZ":   Type11 "000110": lastinstructionwasalabelorbranch = 1
                  CASE "BGTZ":   Type11 "000111": lastinstructionwasalabelorbranch = 1
                  CASE "BEQL":   Type10 "010100": lastinstructionwasalabelorbranch = 1
                  CASE "BNEL":   Type10 "010101": lastinstructionwasalabelorbranch = 1
                  CASE "BLEZL":  Type11 "010110": lastinstructionwasalabelorbranch = 1
                  CASE "BGTZL":  Type11 "010111": lastinstructionwasalabelorbranch = 1

                  'special
                  CASE "SLLV":   Type3 "000100"
                  CASE "SRLV":   Type3 "000110"
                  CASE "SRAV":   Type3 "000111"
                  CASE "DSLLV":  Type3 "010100"
                  CASE "ADD":    Type3 "100000"
                  CASE "ADDU":   Type3 "100001"
                  CASE "SUB":    Type3 "100010"
                  CASE "SUBU":   Type3 "100011"
                  CASE "AND":    Type3 "100100"
                  CASE "OR":     Type3 "100101"
                  CASE "XOR":    Type3 "100110"
                  CASE "NOR":    Type3 "100111"
                  CASE "SLT":    Type3 "101010"
                  CASE "SLTU":   Type3 "101011"
                  CASE "DADD":   Type3 "101100"
                  CASE "DADDU":  Type3 "101101"
                  CASE "DSUB":   Type3 "101110"
                  CASE "DSUBU":  Type3 "101111"
                  CASE "DSRLV":  Type3 "010110"
                  CASE "DSRAV":  Type3 "010111"

                  CASE "SLL":    Type4 "000000"
                  CASE "SRL":    Type4 "000010"
                  CASE "SRA":    Type4 "000011"
                  CASE "DSLL":   Type4 "111000"
                  CASE "DSRL":   Type4 "111010"
                  CASE "DSRA":   Type4 "111011"
                  CASE "DSLL32": Type4 "111100"
                  CASE "DSRL32": Type4 "111110"
                  CASE "DSRA32": Type4 "111111"

                  CASE "MULT":   Type5 "011000"
                  CASE "MULTU":  Type5 "011001"
                  CASE "DIV":    Type5 "011010"
                  CASE "DIVU":   Type5 "011011"
                  CASE "DMULT":  Type5 "011100"
                  CASE "DMULTU": Type5 "011101"
                  CASE "DDIV":   Type5 "011110"
                  CASE "DDIVU":  Type5 "011111"
                  CASE "MFHI":   Type6 "010000"
                  CASE "MFLO":   Type6 "010010"
                  CASE "JR":     Type7 "001000": lastinstructionwasalabelorbranch = 1
                  CASE "MTHI":   Type7 "010001"
                  CASE "MTLO":   Type7 "010011"
                  CASE "SYNC":   Type18 "001111"
                  CASE "JALR":   Type19 "001001": lastinstructionwasalabelorbranch = 1

                  'regimm
                  CASE "BLTZ":    Type9 "00000": lastinstructionwasalabelorbranch = 1
                  CASE "BGEZ":    Type9 "00001": lastinstructionwasalabelorbranch = 1
                  CASE "BLTZL":   Type9 "00010": lastinstructionwasalabelorbranch = 1
                  CASE "BGEZL":   Type9 "00011": lastinstructionwasalabelorbranch = 1
                  CASE "BLTZAL":  Type9 "10000": lastinstructionwasalabelorbranch = 1
                  CASE "BGEZAL":  Type9 "10001": lastinstructionwasalabelorbranch = 1
                  CASE "BLTZALL": Type9 "10010": lastinstructionwasalabelorbranch = 1
                  CASE "BGEZALL": Type9 "10011": lastinstructionwasalabelorbranch = 1

                  CASE "TGEI":   Type31 "01000"
                  CASE "TGEIU":  Type31 "01001"
                  CASE "TLTI":   Type31 "01010"
                  CASE "TLTIU":  Type31 "01011"
                  CASE "TEQI":   Type31 "01100"
                  CASE "TNEI":   Type31 "01110"
               
                  CASE "TEQ":    Type29 "110100"
                  CASE "TGE":    Type29 "110000"
                  CASE "TGEU":   Type29 "110001"
                  CASE "TLT":    Type29 "110010"
                  CASE "TLTU":   Type29 "110011"
                  CASE "TNE":    Type29 "110110"

                  CASE "BREAK":   Type30 "001101"
                  CASE "SYSCALL": Type30 "001100"
               
                  'cop0
                  CASE "MFC0":   Type12 "00000"
                  CASE "DMFC0":  Type12 "00001"
                  CASE "CFC0":   Type12 "00010"
                  CASE "MTC0":   Type12 "00100"
                  CASE "DMTC0":  Type12 "00101"
                  CASE "CTC0":   Type12 "00110"
                  CASE "ERET":   Type13 "011000"
                  CASE "TLBP":   Type13 "001000"
                  CASE "TLBR":   Type13 "000001"
                  CASE "TLBWI":  Type13 "000010"
                  CASE "TLBWR":  Type13 "000110"
                  CASE "BC0F":   Type16 "00": lastinstructionwasalabelorbranch = 1
                  CASE "BC0FL":  Type16 "10": lastinstructionwasalabelorbranch = 1
                  CASE "BC0T":   Type16 "01": lastinstructionwasalabelorbranch = 1
                  CASE "BC0TL":  Type16 "11": lastinstructionwasalabelorbranch = 1
         
                  'cop1
                  CASE "MFC1":      Type14 "00000"
                  CASE "DMFC1":     Type14 "00001"
                  CASE "CFC1":      Type14 "00010"
                  CASE "MTC1":      Type14 "00100"
                  CASE "DMTC1":     Type14 "00101"
                  CASE "CTC1":      Type14 "00110"
                  CASE "BC1F":      Type17 "00": lastinstructionwasalabelorbranch = 1
                  CASE "BC1FL":     Type17 "10": lastinstructionwasalabelorbranch = 1
                  CASE "BC1T":      Type17 "01": lastinstructionwasalabelorbranch = 1
                  CASE "BC1TL":     Type17 "11": lastinstructionwasalabelorbranch = 1
                  CASE "LWC1":      Type32 "110001"
                  CASE "LDC1":      Type32 "110101"
                  CASE "SDC1":      Type32 "111101"
                  CASE "SWC1":      Type32 "111001"
                  CASE "ADD.S":     Type20 "000000"
                  CASE "SUB.S":     Type20 "000001"
                  CASE "MUL.S":     Type20 "000010"
                  CASE "DIV.S":     Type20 "000011"
                  CASE "ADD.D":     Type21 "000000"
                  CASE "SUB.D":     Type21 "000001"
                  CASE "MUL.D":     Type21 "000010"
                  CASE "DIV.D":     Type21 "000011"
                  CASE "ABS.S":     Type22 "000101"
                  CASE "CEIL.L.S":  Type22 "001010"
                  CASE "CEIL.W.S":  Type22 "001110"
                  CASE "CVT.D.S":   Type22 "100001"
                  CASE "CVT.L.S":   Type22 "100101"
                  CASE "CVT.W.S":   Type22 "100100"
                  CASE "FLOOR.L.S": Type22 "001011"
                  CASE "FLOOR.W.S": Type22 "001111"
                  CASE "MOV.S":     Type22 "000110"
                  CASE "NEG.S":     Type22 "000111"
                  CASE "ROUND.L.S": Type22 "001000"
                  CASE "ROUND.W.S": Type22 "001100"
                  CASE "SQRT.S":    Type22 "000100"
                  CASE "TRUNC.L.S": Type22 "001001"
                  CASE "TRUNC.W.S": Type22 "001101"
                  CASE "ABS.D":     Type23 "000101"
                  CASE "CEIL.L.D":  Type23 "001010"
                  CASE "CEIL.W.D":  Type23 "001110"
                  CASE "CVT.S.D":   Type23 "100000"
                  CASE "CVT.L.D":   Type23 "100101"
                  CASE "CVT.W.D":   Type23 "100100"
                  CASE "FLOOR.L.D": Type23 "001011"
                  CASE "FLOOR.W.D": Type23 "001111"
                  CASE "MOV.D":     Type23 "000110"
                  CASE "NEG.D":     Type23 "000111"
                  CASE "ROUND.L.D": Type23 "001000"
                  CASE "ROUND.W.D": Type23 "001100"
                  CASE "SQRT.D":    Type23 "000100"
                  CASE "TRUNC.L.D": Type23 "001001"
                  CASE "TRUNC.W.D": Type23 "001101"
                  CASE "CVT.S.W":   Type24 "100000"
                  CASE "CVT.D.W":   Type24 "100001"
                  CASE "CVT.S.L":   Type25 "100000"
                  CASE "CVT.D.L":   Type25 "100001"
             
                  'compares
                  CASE "C.F.S":     Type27 "0000"
                  CASE "C.UN.S":    Type27 "0001"
                  CASE "C.EQ.S":    Type27 "0010"
                  CASE "C.UEQ.S":   Type27 "0011"
                  CASE "C.OLT.S":   Type27 "0100"
                  CASE "C.ULT.S":   Type27 "0101"
                  CASE "C.OLE.S":   Type27 "0110"
                  CASE "C.ULE.S":   Type27 "0111"
                  CASE "C.SF.S":    Type27 "1000"
                  CASE "C.NGLE.S":  Type27 "1001"
                  CASE "C.SEQ.S":   Type27 "1010"
                  CASE "C.NGL.S":   Type27 "1011"
                  CASE "C.LT.S":    Type27 "1100"
                  CASE "C.NGE.S":   Type27 "1101"
                  CASE "C.LE.S":    Type27 "1110"
                  CASE "C.NGT.S":   Type27 "1111"
                
                  CASE "C.F.D":     Type28 "0000"
                  CASE "C.UN.D":    Type28 "0001"
                  CASE "C.EQ.D":    Type28 "0010"
                  CASE "C.UEQ.D":   Type28 "0011"
                  CASE "C.OLT.D":   Type28 "0100"
                  CASE "C.ULT.D":   Type28 "0101"
                  CASE "C.OLE.D":   Type28 "0110"
                  CASE "C.ULE.D":   Type28 "0111"
                  CASE "C.SF.D":    Type28 "1000"
                  CASE "C.NGLE.D":  Type28 "1001"
                  CASE "C.SEQ.D":   Type28 "1010"
                  CASE "C.NGL.D":   Type28 "1011"
                  CASE "C.LT.D":    Type28 "1100"
                  CASE "C.NGE.D":   Type28 "1101"
                  CASE "C.LE.D":    Type28 "1110"
                  CASE "C.NGT.D":   Type28 "1111"
                  
                  'cop2
                  CASE "DMFC2":  Type15 "00001"
                  CASE "CFC2":   Type15 "00010"
                  CASE "DMTC2":  Type15 "00101"
                  CASE "CTC2":   Type15 "00110"
                  CASE "MFC2":   Type15 "00000"
                  CASE "MTC2":   Type15 "00100"
                  CASE "LWC2":   Type1 "110010"
                  CASE "LDC2":   Type1 "110110"
                  CASE "SDC2":   Type1 "111110"
                  CASE "SWC2":   Type1 "111010"
                
                  'spektakulra ... :-)
                  CASE "BC2F":   Type26 "00": lastinstructionwasalabelorbranch = 1
                  CASE "BC2FL":  Type26 "10": lastinstructionwasalabelorbranch = 1
                  CASE "BC2T":   Type26 "01": lastinstructionwasalabelorbranch = 1
                  CASE "BC2TL":  Type26 "11": lastinstructionwasalabelorbranch = 1

                  'special stuff
                  CASE "DB", ".BYTE":         ByteBlock       'Define Byte
                  CASE "DH", ".HWORD":        HalfBlock       'Define Halfword
                  CASE "DW", "DD", ".WORD":   WordBlock       'Define Doubleword
                  CASE ".DCB", ".BLOCK":      InsertBlock     'mosar in massa kod
                  CASE ".INCBIN", ".FILE":    IncludeBin      'PSY-Q compatiblity (.FILE = asm64)

                  CASE "OPT":                 HandleDirective 'PSY-Q compatiblity
                  CASE "ORG", ".ORG":         'changes orgin
                    known = 1
                    TempAdrXX& = VAL(GetValue32(param$))
                    
                    OpcodePosCnt = TempAdrXX& / 4   'change pointer

                    IF NoHeader = 0 THEN
                       MainCode& = &H1001 + TempAdrXX&   '+1001h so i am after header
                    ELSE
                       MainCode& = &H1 + TempAdrXX&      '+1h so i am at start of file
                    END IF


                  'pseudo opcodes
                  CASE "NOP":    Type0
                  CASE "MOVE":   PseudoType1 "100000"
                  CASE "BNEZ":   PseudoType2 "000101": lastinstructionwasalabelorbranch = 1
                  CASE "BEQZ":   PseudoType2 "000100": lastinstructionwasalabelorbranch = 1
                  CASE "BNEZL":  PseudoType2 "010101": lastinstructionwasalabelorbranch = 1
                  CASE "BEQZL":  PseudoType2 "010100": lastinstructionwasalabelorbranch = 1
                  CASE "NEGU":   PseudoType3 "100011"
                  CASE "NEG":    PseudoType3 "100010"
                  CASE "B":      PseudoType4 "000100": lastinstructionwasalabelorbranch = 1
                  CASE "BAL":    PseudoType5 "10001": lastinstructionwasalabelorbranch = 1
                  CASE "LI":     PseudoType6
                  CASE "S.S":    Type32 "111001"
                  CASE "L.S":    Type32 "110001"


                  'RSP opcodes:

                  'LWC2
                  CASE "LBV":    RSPType1 "110010", "00000", 0
                  CASE "LSV":    RSPType1 "110010", "00001", 1
                  CASE "LLV":    RSPType1 "110010", "00010", 2
                  CASE "LDV":    RSPType1 "110010", "00011", 3
                  CASE "LQV":    RSPType1 "110010", "00100", 4
                  CASE "LRV":    RSPType1 "110010", "00101", 4
                  CASE "LPV":    RSPType1 "110010", "00110", 3
                  CASE "LUV":    RSPType1 "110010", "00111", 3
                  CASE "LHV":    RSPType1 "110010", "01000", 4
                  CASE "LFV":    RSPType1 "110010", "01001", 4
                  CASE "LWV":    RSPType1 "110010", "01010", 4
                  CASE "LTV":    RSPType1 "110010", "01011", 4

                  'SWC2
                  CASE "SBV":    RSPType1 "111010", "00000", 0
                  CASE "SSV":    RSPType1 "111010", "00001", 1
                  CASE "SLV":    RSPType1 "111010", "00010", 2
                  CASE "SDV":    RSPType1 "111010", "00011", 3
                  CASE "SQV":    RSPType1 "111010", "00100", 4
                  CASE "SRV":    RSPType1 "111010", "00101", 4
                  CASE "SPV":    RSPType1 "111010", "00110", 3
                  CASE "SUV":    RSPType1 "111010", "00111", 3
                  CASE "SHV":    RSPType1 "111010", "01000", 4
                  CASE "SFV":    RSPType1 "111010", "01001", 4
                  CASE "SWV":    RSPType1 "111010", "01010", 4
                  CASE "STV":    RSPType1 "111010", "01011", 4

                  'Vector ops
                  CASE "VMULF":  RSPType2 "000000"
                  CASE "VMULU":  RSPType2 "000001"
                  CASE "VRNDP":  RSPType2 "000010"
                  CASE "VMULQ":  RSPType2 "000011"
                  CASE "VMUDL":  RSPType2 "000100"
                  CASE "VMUDM":  RSPType2 "000101"
                  CASE "VMUDN":  RSPType2 "000110"
                  CASE "VMUDH":  RSPType2 "000111"

                  CASE "VMACF":  RSPType2 "001000"
                  CASE "VMACU":  RSPType2 "001001"
                  CASE "VRNDN":  RSPType2 "001010"
                  CASE "VMACQ":  RSPType2 "001011"
                  CASE "VMADL":  RSPType2 "001100"
                  CASE "VMADM":  RSPType2 "001101"
                  CASE "VMADN":  RSPType2 "001110"
                  CASE "VMADH":  RSPType2 "001111"

               END SELECT
            
               IF known = 0 THEN   'bad instruction
                  ErrorCode 2, inst$
                  UnknownInstr = UnknownInstr + 1
               
                  opcode$ = "BAD!"
                  PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
               END IF
           
         LOOP WHILE NOT EOF(1)
    CLOSE #1, #2

END SUB

FUNCTION GetAdr& (tmp$)
   
   'tar reda p addressen fr en label
   DirectJump = 0

   'kollar om tmp$ r en label eller ett direkt vrde:
   ttx = ASC(LEFT$(tmp$, 1))
   ItIsALabel = 0
   IF ttx > 64 AND ttx < 91 THEN ItIsALabel = 1
   IF ttx > 96 AND ttx < 123 THEN ItIsALabel = 1
   IF ttx = ASC("_") THEN ItIsALabel = 1

   IF ItIsALabel = 1 THEN
      flum = LEN(tmp$): hittad& = -1
      
      FOR a& = 0 TO LabelCnt&
          IF LCASE$(LEFT$(Label$(a&), flum + 1)) = LCASE$(tmp$) + ":" THEN
             hittad& = VAL(MID$(Label$(a&), flum + 2))
          END IF
      NEXT
      IF hittad& = -1 THEN
         ErrorCode 3, tmp$
      ELSE
         GetAdr& = hittad&
      END IF
   ELSE
      'direkt vrde:
      ttaxx$ = GetValue32(tmp$)
      GetAdr& = VAL(ttaxx$)
      
      DirectJump = 1        'tells that it is a direct jump.
   END IF

END FUNCTION

FUNCTION GetBranchVal$ (num&)

       IF OpcodePosCnt > num& THEN       'om labeln r innan branchen
          flurp& = OpcodePosCnt - num& - 1
          bra$ = HEX$(&HFFFF& - flurp&)
       ELSE                              'tvrt om
          flurp& = num& - OpcodePosCnt
          bra$ = "0000" + HEX$(flurp&)
          bra$ = RIGHT$(bra$, 4)
       END IF

       bra1$ = MID$(bra$, 1, 2)
       bra2$ = MID$(bra$, 3, 2)

       GetBranchVal = CHR$(VAL("&h" + bra1$)) + CHR$(VAL("&h" + bra2$))

END FUNCTION

FUNCTION GetBranchValBREAK$ (num&)
     
       flurp& = (num& * 4) - OpcodePosCnt
       IF flurp& < 0 THEN
          blur$ = "11"
          blur2$ = "FFFF"
       ELSE
          blur$ = "00"
          blur2$ = "0000"
       END IF
       bra$ = blur2$ + HEX$(flurp&)
       bra$ = RIGHT$(bra$, 4)
       tmp1& = VAL("&h" + bra$)
       
       tmp2$ = ToBin32(tmp1&)

       GetBranchValBREAK = RIGHT$(tmp2$, 20)

END FUNCTION

FUNCTION GetByteValue$ (txt$)
   
    sep1$ = CHR$(34)
    intext = 0

    FOR a = 1 TO LEN(txt$)
        funnen = 0
        kool$ = MID$(txt$, a, 1)
        IF kool$ = sep1$ THEN
           funnen = 1
           IF intext = 0 THEN
              intext = 1
           ELSE
              intext = 0
           END IF
        END IF
        IF funnen = 0 THEN
           IF intext = 1 THEN
              OutStr$ = OutStr$ + kool$
           ELSE
              IF kool$ = "," THEN
                 tmp$ = LTRIM$(MID$(txt$, a + 1))
                 
                 IF LEFT$(tmp$, 1) <> sep1$ THEN
                    jaho = INSTR(tmp$, ",")
                    IF jaho = 0 THEN    'sista delen i raden
                       OutStr$ = OutStr$ + CHR$(VAL(tmp$))
                       a = a + LEN(tmp$)
                    ELSE
                       tmp2$ = LEFT$(tmp$, jaho - 1)
                       tmp3 = VAL(tmp2$)
                       OutStr$ = OutStr$ + CHR$(tmp3)
                       a = a + LEN(tmp2$) - 1
                    END IF
                    funnen = 1
                 END IF
              ELSE
                 OutStr$ = OutStr$ + CHR$(VAL(kool$))
                 a = a + LEN(kool$)
                 funnen = 1
              END IF
           END IF
        END IF
    NEXT a
    
    GetByteValue$ = OutStr$

END FUNCTION

FUNCTION GetDec& (txx$)
    'omvandlar frn hex-textstrng till decimalt

    IF LCASE$(RIGHT$(txx$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(txx$): vxx$ = LEFT$(txx$, tmp1 - 1) 'tar bort h'et p slutet
       tmp1 = LEN(txx$)

       GetDec& = VAL("&h" + vxx$)
       FoundIt = 1
    END IF
    IF LCASE$(LEFT$(txx$, 2)) = "0x" THEN     'hex tal, C++ variant
       vxx$ = MID$(txx$, 3)                   'tar bort 0x i brjan
       tmp1 = LEN(vxx$)

       GetDec& = VAL("&h" + vxx$)
       FoundIt = 1
    END IF

    IF FoundIt = 0 THEN     ' vanligt decimalt tal
       GetDec& = VAL(txx$)
    END IF

END FUNCTION

FUNCTION GetLabelOffset& (labelname$)

      'calculates the offset of a label to insert where $label exists.
      
      flum = LEN(labelname$): hittad& = -1

      FOR a& = 0 TO LabelCnt&
          IF LCASE$(LEFT$(Label$(a&), flum + 1)) = LCASE$(labelname$) + ":" THEN
             hittad& = VAL(MID$(Label$(a&), flum + 2))
          END IF
      NEXT
      IF hittad& = -1 THEN
         ErrorCode 3, tmp$
      ELSE
         'PRINT HEX$(hittad& * 4)
         GetLabelOffset& = BaseAdr& + (hittad& * 4)
      END IF


END FUNCTION

FUNCTION GetRCPel (txt$)

    SELECT CASE txt$
       CASE "": ReturnVal = 0
       CASE "[0q]":  ReturnVal = 2
       CASE "[1q]":  ReturnVal = 3
       CASE "[0h]":  ReturnVal = 4
       CASE "[1h]":  ReturnVal = 5
       CASE "[2h]":  ReturnVal = 6
       CASE "[3h]":  ReturnVal = 7
       CASE "[0]":   ReturnVal = 8
       CASE "[1]":   ReturnVal = 9
       CASE "[2]":   ReturnVal = 10
       CASE "[3]":   ReturnVal = 11
       CASE "[4]":   ReturnVal = 12
       CASE "[5]":   ReturnVal = 13
       CASE "[6]":   ReturnVal = 14
       CASE "[7]":   ReturnVal = 15
       CASE ELSE:
          PRINT "Unknown RCP vector EL value: "; txt$
          END
    END SELECT

    GetRCPel = ReturnVal

END FUNCTION

SUB GetSyntax
  
   Syntax$ = UCASE$(Syntax$) + " "

   temp = INSTR(Syntax$, "-BYTESWAP ")
   IF temp THEN
      ByteSwap = 1  ' byteswapping ON
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 10)
   END IF

   temp = INSTR(Syntax$, "-KEEPFILE ")
   IF temp THEN
      KeepFile = 1  ' keep file if error occurs
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 10)
   END IF

   temp = INSTR(Syntax$, "-EQU")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 5)
      IF tempD$ <> "" THEN
         CheckEQUTimes = VAL(tempD$)
      END IF
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF

   temp = INSTR(Syntax$, "-ERR")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 5)
      IF tempD$ <> "" THEN
         MaxErrors = VAL(tempD$)
      END IF
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF

   temp = INSTR(Syntax$, "-HEADER ")
   IF temp THEN
      NoHeader = 0   'generates header
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 8)
   END IF

   temp = INSTR(Syntax$, "-ALIGN")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 7)
      IF tempD$ <> "" THEN
         AlignTmp = VAL(tempD$)
      END IF
      SELECT CASE AlignTmp
          CASE 2, 4, 8: AlignSize = AlignTmp
          CASE ELSE: ErrorCode 14, tempD$
      END SELECT
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF






   Syntax$ = LTRIM$(RTRIM$(Syntax$))
   IF Syntax$ <> "" THEN
      ttmp = INSTR(Syntax$, " -")
      IF ttmp THEN ShowSyntax LTRIM$(MID$(Syntax$, ttmp))
      IF LEFT$(Syntax$, 1) = "-" THEN
         ttmp = INSTR(Syntax$, " ")
         ShowSyntax LTRIM$(MID$(Syntax$, 1, ttmp - 1))
      END IF
      InFile$ = Syntax$
   ELSE
      ShowSyntax ""
   END IF


   temp = INSTR(InFile$, ".")
   IF temp = 0 THEN
      OutFile$ = InFile$
   ELSE
      OutFile$ = LEFT$(InFile$, temp - 1)
      DO
        temp = INSTR(TempFile2$, "\")
        IF temp > 0 THEN
           OutFile$ = MID$(TempFile2$, temp + 1)
        ELSE
           slutvillkor = 1
        END IF
      LOOP WHILE slutvillkor = 0
   END IF


END SUB

FUNCTION GetTrueVal16& (flump$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)
    flump$ = LTRIM$(RTRIM$(flump$))
    IF LCASE$(RIGHT$(flump$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort h'et p slutet
       FoundIt = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          GetTrueVal16 = knorr&
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF
    IF LCASE$(LEFT$(flump$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = RIGHT$(flump$, tmp1 - 1)  'tar bort $
       FoundIt = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          GetTrueVal16 = knorr&
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF

    IF LCASE$(LEFT$(flump$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF FoundIt = 0 THEN
          flump$ = MID$(flump$, 3)                   'tar bort 0x i brjan
          FoundIt = 1
          knorr& = VAL("&h" + flump$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF
 
    IF LCASE$(RIGHT$(flump$, 1)) = "b" THEN    'binr tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort b
          FoundIt = 1
          knorr& = FromBin32(flump$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF

    IF LCASE$(RIGHT$(flump$, 1)) = "d" THEN    'decimal tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          FoundIt = 1
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF




    IF FoundIt = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flump$)))
       IF tsrmp$ = flump$ THEN  ' ja vanligt decimaltal
          FoundIt = 1
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16& = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       ELSE
          ErrorCode 8, flump$
       END IF
    END IF

END FUNCTION

FUNCTION GetTrueVal32& (invar$)
  
    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)

    FoundIt = 0
    
    flemp$ = LTRIM$(RTRIM$(invar$))
    IF LCASE$(RIGHT$(flemp$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort h'et p slutet
       FoundIt = 1
       GetTrueVal32& = VAL("&h" + flemp$)
    END IF

    IF LCASE$(LEFT$(flemp$, 1)) = "$" THEN    'label offset
       FoundIt = 1
       IF Pass > 1 THEN  'make sure we've looked up labels correctly
          flemp$ = MID$(flemp$, 2)  'tar bort $
          
          'debugging message
          'PRINT flemp$; ": "; HEX$(GetLabelOffset(flemp$))

          GetTrueVal32& = GetLabelOffset(flemp$)
       END IF
    END IF


    IF LCASE$(LEFT$(flemp$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF FoundIt = 0 THEN
          flemp$ = MID$(flemp$, 3)                   'tar bort 0x i brjan
          FoundIt = 1
          GetTrueVal32& = VAL("&h" + flemp$)
       END IF
    END IF
 
    IF LCASE$(RIGHT$(flemp$, 1)) = "b" THEN    'binr tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort b
          FoundIt = 1
          GetTrueVal32& = FromBin32(flemp$)
       END IF
    END IF

    IF LCASE$(RIGHT$(flemp$, 1)) = "d" THEN    'decimal tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)'tar bort b
          FoundIt = 1
          GetTrueVal32& = VAL(flemp$)
       END IF
    END IF

    IF FoundIt = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flemp$)))
       IF tsrmp$ = flemp$ THEN  ' ja vanligt decimaltal
          GetTrueVal32& = VAL(flemp$)
       ELSE
          ErrorCode 8, flemp$
       END IF
    END IF


END FUNCTION

FUNCTION GetVal16$ (flump$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)
    flump$ = LTRIM$(RTRIM$(flump$))
    IF LCASE$(RIGHT$(flump$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort h'et p slutet
       FoundIt = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          flump$ = "0000" + flump$
          flump$ = RIGHT$(flump$, 4)
          FOR a = 1 TO LEN(flump$) STEP 2
              del = VAL("&h" + MID$(flump$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal16$ = temp$
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF
    IF LCASE$(LEFT$(flump$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = RIGHT$(flump$, tmp1 - 1)  'tar bort $
       FoundIt = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          flump$ = "0000" + flump$
          flump$ = RIGHT$(flump$, 4)
          FOR a = 1 TO LEN(flump$) STEP 2
              del = VAL("&h" + MID$(flump$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal16$ = temp$
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF


    IF LCASE$(LEFT$(flump$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF FoundIt = 0 THEN
          flump$ = MID$(flump$, 3)                   'tar bort 0x i brjan
          FoundIt = 1
          knorr& = VAL("&h" + flump$)
          IF knorr& < 65536 THEN      'overflow checking
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(flump$) STEP 2
                del = VAL("&h" + MID$(flump$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF
  
    IF LCASE$(RIGHT$(flump$, 1)) = "b" THEN    'binr tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort b
          FoundIt = 1
          knorr& = FromBin32(flump$)
          IF knorr& < 65536 THEN      'overflow checking
             knas$ = HEX$(FromBin32(flump$))
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                del = VAL("&h" + MID$(knas$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, flump$
          END IF
       END IF
    END IF

    IF LCASE$(RIGHT$(flump$, 1)) = "d" THEN    'decimal tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          FoundIt = 1
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                del = VAL("&h" + MID$(knas$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, LTRIM$(STR$(knorr&))
          END IF
       END IF
    END IF



    IF FoundIt = 0 THEN
       IF LEFT$(flump$, 1) = CHR$(34) THEN    'text strng
          IF RIGHT$(flump$, 1) = CHR$(34) THEN    'text strng
             tmp1 = LEN(flump$)
             GetVal16$ = MID$(flump$, 2, tmp1 - 2)
          ELSE
             PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
          END IF
          FoundIt = 1
       END IF
    END IF

    IF FoundIt = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flump$)))
       IF tsrmp$ = flump$ THEN  ' ja vanligt decimaltal
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             knas$ = "0000" + knas$
             knas$ = RIGHT$(knas$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                 del = VAL("&h" + MID$(knas$, a, 2))
                 temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
             FoundIt = 1
          ELSE
             ErrorCode 9, LTRIM$(STR$(knorr&))
          END IF
       ELSE
          ErrorCode 8, flump$
       END IF
    END IF

END FUNCTION

FUNCTION GetVal32$ (invar$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)

    FoundIt = 0

    flemp$ = LTRIM$(RTRIM$(invar$))
    IF LCASE$(RIGHT$(flemp$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort h'et p slutet
       FoundIt = 1
       flemp$ = "0000" + flemp$
       flemp$ = RIGHT$(flemp$, 8)
       FOR a = 1 TO LEN(flemp$) STEP 2
           del = VAL("&h" + MID$(flemp$, a, 2))
           temp$ = temp$ + CHR$(del)
       NEXT a
       GetVal32$ = temp$
    END IF

    IF LCASE$(LEFT$(flemp$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = RIGHT$(flemp$, tmp1 - 1)  'tar bort $
       FoundIt = 1
       flemp$ = "0000" + flemp$
       flemp$ = RIGHT$(flemp$, 8)
       FOR a = 1 TO LEN(flemp$) STEP 2
           del = VAL("&h" + MID$(flemp$, a, 2))
           temp$ = temp$ + CHR$(del)
       NEXT a
       GetVal32$ = temp$
    END IF


    IF LCASE$(LEFT$(flemp$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF FoundIt = 0 THEN
          flemp$ = MID$(flemp$, 3)                   'tar bort 0x i brjan
          FoundIt = 1
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 8)
          FOR a = 1 TO LEN(flemp$) STEP 2
              del = VAL("&h" + MID$(flemp$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF
  
    IF LCASE$(RIGHT$(flemp$, 1)) = "b" THEN    'binr tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort b
          FoundIt = 1
          knas$ = HEX$(FromBin32(flemp$))
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 32)
          FOR a = 1 TO LEN(knas$) STEP 2
              del = VAL("&h" + MID$(knas$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF

    IF LCASE$(RIGHT$(flemp$, 1)) = "d" THEN    'decimal tal
       IF FoundIt = 0 THEN
          tmp1 = LEN(flemp$)
          knas$ = HEX$(VAL(flemp$))
          FoundIt = 1
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 8)
          FOR a = 1 TO LEN(knas$) STEP 2
              del = VAL("&h" + MID$(knas$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF

    IF FoundIt = 0 THEN
       IF LEFT$(flemp$, 1) = CHR$(34) THEN    'text strng
          IF RIGHT$(flemp$, 1) = CHR$(34) THEN    'text strng
             tmp1 = LEN(flemp$)
             GetVal32$ = MID$(flemp$, 2, tmp1 - 2)
          ELSE
             PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
          END IF
          FoundIt = 1
       END IF
    END IF

    IF FoundIt = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flemp$)))
       IF tsrmp$ = flemp$ THEN  ' ja vanligt decimaltal
          tmp1 = LEN(flemp$)
          knas$ = HEX$(VAL(flemp$))
          knorr& = VAL("&h" + knas$)

             knas$ = "0000" + knas$
             knas$ = RIGHT$(knas$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                 del = VAL("&h" + MID$(knas$, a, 2))
                 temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal32$ = temp$
             FoundIt = 1
       ELSE
          ErrorCode 8, flemp$
       END IF
    END IF

END FUNCTION

FUNCTION GetValue16$ (flump$)

     'supports complex calculation :)

     flumpie$ = CalculateThis(flump$)
     done1& = GetTrueVal16(flumpie$)
     GetValue16$ = STR$(done1&)

END FUNCTION

FUNCTION GetValue32$ (flump$)


   '1. kolla om det r $label
   '2. kolla om det r +-*/ i strngen
   '  2a. dela upp i 2 delar
   '  2b. kalkylera
   '3. omvandla till tal


      vrump1 = CountStr(flump$, "+")
      vrump2 = CountStr(flump$, "-")
      vrump3 = CountStr(flump$, "*")
      vrump4 = CountStr(flump$, "/")

      'line below: if it is a minus value.
      IF LEFT$(flump$, 1) = "-" THEN vrump2 = vrump2 - 1
 
      vjamp = vrump1 + vrump2 + vrump3 + vrump4
   
      IF vjamp > 0 THEN
         IF vjamp > 1 THEN
            'advanced mathematics
            ErrorCode 11, flump$
         ELSE
            IF vrump1 THEN  'plus
               tmp = INSTR(flump$, "+")
               del1$ = LEFT$(flump$, tmp - 1)
               del2$ = MID$(flump$, tmp + 1)
               del1a& = GetTrueVal32(del1$)
               del2a& = GetTrueVal32(del2$)
               svaret& = del1a& + del2a&
               flump$ = LTRIM$(STR$(svaret&))
            END IF
            IF vrump2 THEN  'minus
               tmp = INSTR(flump$, "-")
               del1$ = LEFT$(flump$, tmp - 1)
               del2$ = MID$(flump$, tmp + 1)
               del1a& = GetTrueVal32(del1$)
               del2a& = GetTrueVal32(del2$)
               svaret& = del1a& - del2a&
               flump$ = LTRIM$(STR$(svaret&))
            END IF
            IF vrump3 THEN  'gnger
               tmp = INSTR(flump$, "*")
               del1$ = LEFT$(flump$, tmp - 1)
               del2$ = MID$(flump$, tmp + 1)
               del1a& = GetTrueVal32(del1$)
               del2a& = GetTrueVal32(del2$)
               svaret& = del1a& * del2a&
               flump$ = LTRIM$(STR$(svaret&))
            END IF
            IF vrump4 THEN  'delat med
               tmp = INSTR(flump$, "/")
               del1$ = LEFT$(flump$, tmp - 1)
               del2$ = MID$(flump$, tmp + 1)
               del1a& = GetTrueVal32(del1$)
               del2a& = GetTrueVal32(del2$)
               svaret& = del1a& / del2a&
               flump$ = LTRIM$(STR$(svaret&))
            END IF
            done1& = GetTrueVal32(flump$)
            GetValue32$ = STR$(done1&)
         END IF
      ELSE
         done1& = GetTrueVal32(flump$)
         GetValue32$ = STR$(done1&)
      END IF

   

END FUNCTION

SUB HalfBlock
   
    'vet inte hur mnga delar det finns i db blocket, s jag rknar alla
    ' kommatecken ",":

    paramcnt = 0
    FOR a = 1 TO LEN(param$)
        jos$ = MID$(param$, a, 1)
        IF jos$ = "," THEN paramcnt = paramcnt + 1
    NEXT a
  
    SplitParam param$, paramcnt + 1: known = 1
   
    IF ParamErr = 0 THEN
       FOR a = 1 TO paramcnt + 1  'dumpar varje dword
           opcode$ = GetVal16(Parameter$(a))
           opcode$ = CHR$(0) + CHR$(0) + opcode$
           opcode$ = RIGHT$(opcode$, 2)
           PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 2
       NEXT a
    END IF

END SUB

SUB HandleDirective

    known = 1
    ErrorCode 12, param$


END SUB

SUB IncludeBin
      
    IncBinFile$ = GetByteValue(param$): known = 1
    
    IF IncBinFile$ <> "" THEN
       ErrFile$ = IncBinFile$
       OPEN ErrFile$ FOR BINARY AS #5
      
       IncBinLen& = LOF(5)
       IF IncBinLen& = 0 THEN
          PRINT "file not exist"
          CLOSE #5
          IF DebugMode = 0 THEN KILL IncBinFile$
       ELSE
          PRINT "     Including binary file '"; UCASE$(IncBinFile$); "' ("; LTRIM$(STR$(IncBinLen&)); " bytes)... ";
          RestCode& = MainCode&
          IncPoint& = &H1
          towrite# = IncBinLen&
          DO
             IF towrite# > 7000 THEN
                tmp$ = SPACE$(7000)
                GET #5, IncPoint&, tmp$
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + 7000
                IncPoint& = IncPoint& + 7000
                towrite# = towrite# - 7000
             ELSE
                tmp$ = SPACE$(towrite#)
                GET #5, IncPoint&, tmp$
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + towrite#
                endvillkor = 1
             END IF
          LOOP UNTIL endvillkor = 1
          PRINT "Done."
          MainCode& = RestCode&
          CLOSE #5

       END IF
       

 
    END IF


               
                


END SUB

SUB InsertBlock

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       totlen& = VAL(GetValue16(Parameter$(1)))
       charEn = VAL(GetValue16(Parameter$(2)))

       endvillkor = 0
       IF totlen& > 0 THEN
          PRINT "     Inserting"; totlen&; "bytes... ";
          RestCode& = MainCode&
          DO
             towrite# = totlen&
             IF towrite# > 7000 THEN
                tmp$ = STRING$(7000, CHR$(charEn))
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + 7000
                totlen& = totlen& - 7000
             ELSE
                tmp$ = STRING$(towrite#, CHR$(charEn))
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + towrite#
                endvillkor = 1
             END IF
          LOOP UNTIL endvillkor = 1
          PRINT "Done."
          MainCode& = RestCode&

       END IF

  
    END IF



END SUB

DEFSNG A-Z
FUNCTION ParseText$ (text$)

leftfound = 0
rightfound = 0
calc$ = ""
find1 = 0
find2 = 0
find3 = 0
find4 = 0
find5 = 0
find6 = 0
new$ = ""
answer$ = ""

FOR a = 1 TO LEN(text$)
    del$ = MID$(text$, a, 1)

    IF del$ = "(" THEN
       leftfound = leftfound + 1
    END IF
    IF del$ = ")" THEN
       leftfound = leftfound - 1
       IF leftfound = -1 THEN      'error
          PRINT "Syntax error"
          EXIT FOR
       END IF
       rightfound = rightfound + 1
    END IF

    IF leftfound = 0 THEN
       IF calc$ <> "" THEN
          'rkna ut innehllet i calc$

          calc$ = MID$(calc$, 2)        'removes first '('
          find1 = INSTR(calc$, "*")
          find2 = INSTR(calc$, "/")
          find3 = INSTR(calc$, "+")
          find4 = INSTR(calc$, "-")

          find5 = INSTR(calc$, "(")
          find6 = INSTR(calc$, ")")

          IF find1 + find2 + find3 + find4 + find5 + find6 = 0 THEN
             'no calculation needed
             new$ = new$ + calc$
          ELSE
             'PRINT "need to calculate "; calc$
             IF find1 > 0 AND find2 + find3 + find4 + find5 + find6 = 0 THEN  '*
                tmp1 = VAL(MID$(calc$, 1, find1 - 1))
                tmp2 = VAL(MID$(calc$, find1 + 1))
                answer$ = LTRIM$(STR$(tmp1 * tmp2))
                new$ = new$ + answer$

             ELSEIF find2 > 0 AND find1 + find3 + find4 + find5 + find6 = 0 THEN  '/
                tmp1 = VAL(MID$(calc$, 1, find2 - 1))
                tmp2 = VAL(MID$(calc$, find2 + 1))
                answer$ = LTRIM$(STR$(tmp1 / tmp2))
                new$ = new$ + answer$

             ELSEIF find3 > 0 AND find1 + find2 + find4 + find5 + find6 = 0 THEN  '+
                tmp1 = VAL(MID$(calc$, 1, find3 - 1))
                tmp2 = VAL(MID$(calc$, find3 + 1))
                answer$ = LTRIM$(STR$(tmp1 + tmp2))
                new$ = new$ + answer$

             ELSEIF find4 > 0 AND find1 + find2 + find3 + find5 + find6 = 0 THEN  '-
                tmp1 = VAL(MID$(calc$, 1, find4 - 1))
                tmp2 = VAL(MID$(calc$, find4 + 1))
                answer$ = LTRIM$(STR$(tmp1 - tmp2))
                new$ = new$ + answer$

             ELSE
                'PRINT "Annoying format '"; calc$; "'"
                IF find5 > 0 THEN   '(
                   IF find6 > 0 THEN
                      klasleft = 0
                      klasright = 0
                      FOR ketch = 1 TO LEN(calc$)
                          bobba$ = MID$(calc$, ketch, 1)
                          IF bobba$ = "(" THEN klasleft = klasleft + 1
                          IF bobba$ = ")" THEN klasright = klasright + 1
                      NEXT ketch

                      IF klasleft > 1 AND klasright > 1 THEN
                         tmp1$ = MID$(calc$, 1, find5 - 1)
                         tmp2$ = MID$(calc$, find5, find6 - find5 + 1)
                         tmp3$ = MID$(calc$, find6 + 1)
                         new$ = new$ + "`" + tmp1$ + tmp2$ + tmp3$ + "'"
                      ELSE    'shorten down code more.
                         firstie = INSTR(calc$, "(")
                         lastie = INSTR(calc$, ")")
                         beforethis$ = MID$(calc$, 1, firstie - 1)
                         calcthis$ = MID$(calc$, firstie + 1, lastie - firstie - 1)
                         afterthis$ = MID$(calc$, lastie + 1)

                         finishthis$ = ParseText2ndRound(calcthis$)
                         
                         mertmp$ = beforethis$ + finishthis$ + afterthis$
                         
                         finishthis$ = ParseText2ndRound(mertmp$)
                         new$ = new$ + finishthis$
                         
                      END IF
                   ELSE
                      PRINT "Syntax error."
                   END IF
                ELSE
                   PRINT "Something is wrong '"; calc$; "'"
                END IF
             END IF

          END IF

          calc$ = ""
       ELSE
          new$ = new$ + del$
       END IF
    ELSE
       calc$ = calc$ + del$
    END IF
NEXT a


ParseText$ = new$

END FUNCTION

FUNCTION ParseText2ndRound$ (orgtext$)

'rkna ut * och /
DO
   look1 = INSTR(orgtext$, "*")
   look2 = INSTR(orgtext$, "/")
   IF look1 = 0 AND look2 = 0 THEN  'finished
      EXIT DO
   END IF

   IF look1 > look2 THEN   'selects wich one to look for first
      IF look2 > 0 THEN
         tmp = look2: typie$ = "/"
      ELSE
         tmp = look1: typie$ = "*"
      END IF
   ELSE
      IF look1 > 0 THEN
         tmp = look1: typie$ = "*"
      ELSE
         tmp = look2: typie$ = "/"
      END IF
   END IF

   del1$ = MID$(orgtext$, 1, tmp - 1)
   del2$ = MID$(orgtext$, tmp + 1)
   del1corr$ = "": del2corr$ = ""

   FOR findleft = LEN(del1$) TO 1 STEP -1
       del1part$ = MID$(del1$, findleft, 1)
       IF del1part$ = "*" OR del1part$ = "/" OR del1part$ = "+" OR del1part$ = "-" THEN
          EXIT FOR
       END IF
       del1corr$ = del1part$ + del1corr$
   NEXT findleft
   
   FOR findright = 1 TO LEN(del2$)
       del2part$ = MID$(del2$, findright, 1)
       IF del2part$ = "*" OR del2part$ = "/" OR del2part$ = "+" OR del2part$ = "-" THEN
          EXIT FOR
       END IF
       del2corr$ = del2corr$ + del2part$
   NEXT findright
   
   'calculate the stuff:
   IF typie$ = "*" THEN
      answer$ = LTRIM$(STR$(VAL(del1corr$) * VAL(del2corr$)))
   ELSE
      answer$ = LTRIM$(STR$(VAL(del1corr$) / VAL(del2corr$)))
   END IF

   step1$ = MID$(orgtext$, 1, findleft)
   step2$ = MID$(orgtext$, findleft + LEN(del1corr$) + 1 + LEN(del2corr$) + 1)
   orgtext$ = step1$ + answer$ + step2$

LOOP








'rkna ut + och -
DO
   look1 = INSTR(orgtext$, "+")
   look2 = INSTR(orgtext$, "-")

   IF look1 = 1 THEN look1 = 0  'if a number is displayed as "+123"
   IF look2 = 1 THEN look2 = 0  'if a number is displayed as "-123"
   
   IF look1 = 0 AND look2 = 0 THEN  'finished
      EXIT DO
   END IF

   IF look1 > look2 THEN   'selects wich one to look for first
      IF look2 > 0 THEN
         tmp = look2: typie$ = "-"
      ELSE
         tmp = look1: typie$ = "+"
      END IF
   ELSE
      IF look1 > 0 THEN
         tmp = look1: typie$ = "+"
      ELSE
         tmp = look2: typie$ = "-"
      END IF
   END IF

   del1$ = MID$(orgtext$, 1, tmp - 1)
   del2$ = MID$(orgtext$, tmp + 1)
   del1corr$ = "": del2corr$ = ""

   FOR findleft = LEN(del1$) TO 1 STEP -1
       del1part$ = MID$(del1$, findleft, 1)
       IF del1part$ = "*" OR del1part$ = "/" OR del1part$ = "+" OR del1part$ = "-" THEN
          EXIT FOR
       END IF
       del1corr$ = del1part$ + del1corr$
   NEXT findleft

   FOR findright = 1 TO LEN(del2$)
       del2part$ = MID$(del2$, findright, 1)
       IF del2part$ = "*" OR del2part$ = "/" OR del2part$ = "+" OR del2part$ = "-" THEN
          EXIT FOR
       END IF
       del2corr$ = del2corr$ + del2part$
   NEXT findright

   'calculate the stuff:
   IF typie$ = "+" THEN
      answer$ = LTRIM$(STR$(VAL(del1corr$) + VAL(del2corr$)))
   ELSE
      answer$ = LTRIM$(STR$(VAL(del1corr$) - VAL(del2corr$)))
   END IF

   step1$ = MID$(orgtext$, 1, findleft)
   step2$ = MID$(orgtext$, findleft + LEN(del1corr$) + 1 + LEN(del2corr$) + 1)
   orgtext$ = step1$ + answer$ + step2$

LOOP







ParseText2ndRound$ = orgtext$

END FUNCTION

DEFINT A-Z
SUB PseudoType1 (xxx$)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "00000" + ValidReg(Parameter$(2))
       tmpYY$ = ValidReg(Parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType2 (xxx$)
   
    'bnez rs,offset

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(1)) + "00000"

       value& = GetAdr(Parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType3 (xxx$)
   
    'negu rd, rs

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "00000" + ValidReg(Parameter$(2))
       tmpYY$ = ValidReg(Parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType4 (xxx$)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00000" + "00000"

       value& = GetAdr(Parameter$(1))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType5 (xxx$)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000001" + "00000" + xxx$

       value& = GetAdr(Parameter$(1))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType6
   
    'LI    at,0x12345678: (not optimized)

    'LUI   at,0x1234
    'ORI   at,at,0x5678
    '----------------
    'LI    a0,0x4321:    (optimized)
    '
    'ADDIU a0,zero,0x4321

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       thistmp$ = RIGHT$("00000000" + HEX$(VAL(GetValue32(Parameter$(2)))), 8)

       low16$ = "0x" + RIGHT$(thistmp$, 4)
       hi16$ = "0x" + LEFT$(thistmp$, 4)
       
'       IF hi16$ <> "0x0000" THEN
          'LUI - hi16
          tmpXX$ = "00111100000" + ValidReg(Parameter$(1))
          opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(hi16$)
          PUT #2, MainCode&, opcode$
          MainCode& = MainCode& + 4

          'ORI - low16
          tmpXX$ = "001101" + ValidReg(Parameter$(1)) + ValidReg(Parameter$(1))
          opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(low16$)
          PUT #2, MainCode&, opcode$
          MainCode& = MainCode& + 4

          OpcodePosCnt = OpcodePosCnt + 1

'LI optimization removed.
'       ELSE
'          'ADDIU - low16
'          tmpXX$ = "001001" + "00000" + ValidReg(Parameter$(1))
'          opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(low16$)
'          PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
'       END IF
    END IF

END SUB

FUNCTION RemoveTrash$ (txt$)
   
    OutDelen$ = ""
    FOR vaa = 1 TO LEN(txt$)
      juka$ = MID$(txt$, vaa, 1)
      IF juka$ = CHR$(9) THEN juka$ = " "
      
      OutDelen$ = OutDelen$ + juka$
    NEXT vaa
   
    RemoveTrash = OutDelen$

END FUNCTION

SUB RSPType1 (xxx$, xxx2$, shiftie)

    '|  110010   |  base   |  dest   |  00100  |  del  |0|   offset  |
    '------6----------5---------5---------5--------4----1------6------
    ' Format:  LQV $v<dest>[del], offset(base)

    SplitParam param$, 3: known = 1

    RCPTemp = INSTR(Parameter$(1), "[")
    RCPTempParm1$ = RTRIM$(MID$(Parameter$(1), 1, RCPTemp - 1))   'split parm1
    RCPTempParm2$ = MID$(Parameter$(1), RCPTemp + 1)              ' - "" -
    FixedParam3Temp& = VAL(GetValue16(Parameter$(3)))

    moretemp& = SHR(FixedParam3Temp&, shiftie)
    FixedParam3$ = RIGHT$(ToBin8(moretemp&), 6) 'only use lower 6 bits.
    
    
    RCPTemp = INSTR(RCPTempParm2$, "]")                  'remove []
    RCPTempParm2$ = MID$(RCPTempParm2$, 1, RCPTemp - 1)  ' -""-
    RCPTempParm2Bin$ = RIGHT$(ToBin8(VAL(RCPTempParm2$)), 4)   'ignore upper 4 bits, only use lower 4

    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(2)) + ValidRSPReg(RCPTempParm1$)
       tmpYY$ = xxx2$ + RCPTempParm2Bin$ + "0" + FixedParam3$
       
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB RSPType2 (xxx$)

  '|-----------|---------------------------------------------------|
  '|  010010   |1|  el   |   s2    |   s1    |  dest   |  000100   |
  '------6------1----4--------5---------5---------5----------6------
  'Format:  VMUDL $v<dest>, $v<s1>, $v<s2>[el]

    SplitParam param$, 3: known = 1

    RCPTemp = INSTR(Parameter$(3), "[")
    IF RCPTemp > 0 THEN
       RCPTempParm1$ = RTRIM$(MID$(Parameter$(3), 1, RCPTemp - 1))   'split parm1
       RCPTempParm2$ = MID$(Parameter$(3), RCPTemp)                  ' - "" -
       moretemp& = GetRCPel(RCPTempParm2$)
       ELValue$ = RIGHT$(ToBin8(moretemp&), 4)
    ELSE
       RCPTempParm1$ = Parameter$(3)
       ELValue$ = "0000"   'zero, because missing EL
    END IF


    IF ParamErr = 0 THEN
       tmpXX$ = "010010" + "1" + ELValue$ + ValidRSPReg(RCPTempParm1$)
       tmpYY$ = ValidRSPReg(Parameter$(2)) + ValidRSPReg(Parameter$(1)) + xxx$

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB SetStartVars

  Version$ = "Nintendo 64 ToolKit: R4300i assembler v0.42a by anarko <anarko@flashback.net>"
  Reg$(0) = "r0":  Reg$(8) = "t0": Reg$(16) = "s0": Reg$(24) = "t8"
  Reg$(1) = "at":  Reg$(9) = "t1": Reg$(17) = "s1": Reg$(25) = "t9"
  Reg$(2) = "v0": Reg$(10) = "t2": Reg$(18) = "s2": Reg$(26) = "k0"
  Reg$(3) = "v1": Reg$(11) = "t3": Reg$(19) = "s3": Reg$(27) = "k1"
  Reg$(4) = "a0": Reg$(12) = "t4": Reg$(20) = "s4": Reg$(28) = "gp"
  Reg$(5) = "a1": Reg$(13) = "t5": Reg$(21) = "s5": Reg$(29) = "sp"
  Reg$(6) = "a2": Reg$(14) = "t6": Reg$(22) = "s6": Reg$(30) = "s8"
  Reg$(7) = "a3": Reg$(15) = "t7": Reg$(23) = "s7": Reg$(31) = "ra"
  FOR a = 0 TO 31: Reg2$(a) = "reg" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31: Reg3$(a) = "r" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31
      IF a < 10 THEN
         Reg4$(a) = "r0" + LTRIM$(STR$(a))
      ELSE
         Reg4$(a) = "r" + LTRIM$(STR$(a))
      END IF
  NEXT a
  
  FReg$(0) = "index": FReg$(1) = "random": FReg$(2) = "entrylo0"
  FReg$(3) = "entrylo1": FReg$(4) = "context": FReg$(5) = "pagemask"
  FReg$(6) = "wired": FReg$(7) = "": FReg$(8) = "badvaddr"
  FReg$(9) = "count": FReg$(10) = "entryhi": FReg$(11) = "compare"
  FReg$(12) = "status": FReg$(13) = "cause": FReg$(14) = "epc"
  FReg$(15) = "previd": FReg$(16) = "config": FReg$(17) = "lladdr"
  FReg$(18) = "watchlo": FReg$(19) = "watchhi": FReg$(20) = "xcontext"
  FReg$(21) = "": FReg$(22) = "": FReg$(23) = "": FReg$(24) = ""
  FReg$(25) = "": FReg$(26) = "perr": FReg$(27) = "cacheerr"
  FReg$(28) = "taglo": FReg$(29) = "taghi": FReg$(30) = "errorepc"
  FReg$(31) = ""
  FOR a = 0 TO 31
      IF a < 10 THEN
         FReg2$(a) = "c0" + LTRIM$(STR$(a))
      ELSE
         FReg2$(a) = "c" + LTRIM$(STR$(a))
      END IF
  NEXT a

  FOR a = 0 TO 31: RSPReg$(a) = "v" + LTRIM$(STR$(a)): NEXT a

  FOR a = 0 TO 31: CP2Reg$(a) = "fp" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31: CP2BReg$(a) = "f" + LTRIM$(STR$(a)): NEXT a

END SUB

FUNCTION shl# (var&, steps)

   'lgger till "steps" antal "0" p hgersidan av binrtalet

   fftmp$ = ToBin16$(var&)

   FOR kaka = 1 TO steps + 1
       fftmp$ = RIGHT$(fftmp$, 15) + "0"
   NEXT kaka
   shl# = FromBin32(fftmp$)

END FUNCTION

SUB ShowSyntax (txt$)

    PRINT "  Syntax: N64ASM [options] <filename.asm>"
    PRINT
    PRINT " -byteswap  Byteswaps image (def=OFF)"
    PRINT " -header    Creates a header for the image (def=OFF)"
    PRINT " -keepfile  Does not delete the outfile if errors occours (def=OFF)"
    PRINT " -equX      Checks each line after EQU's X times (def=2)"
    PRINT " -errX      Stops assembling after X errors (def=100)"
    PRINT " -alignX    Stores zeroes until address is divisible by 2, 4 or 8 (def=4)"

   
    IF txt$ <> "" THEN
       PRINT
       PRINT " Unknown parameter: "; txt$
    END IF
   
    END

END SUB

FUNCTION SHR# (var&, steps)
   'lgger till "steps" antal "0" p vnstersidan av binrtalet

   
   fftmp$ = ToBin16$(var&)

   fftmp$ = STRING$(steps, "0") + fftmp$
   fftmp$ = LEFT$(fftmp$, 16)
   
   SHR# = FromBin32(fftmp$)

END FUNCTION

SUB SplitParam (some$, trams)
    
     fiasko = INSTR(some$, "^__^")
     IF fiasko > 0 THEN
        IF LabelCnt& < 1000 THEN
           Label$(LabelCnt&) = MID$(some$, fiasko + 8) + STR$(MainCode& - 1)
           LabelCnt& = LabelCnt& + 1
           some$ = RTRIM$(LEFT$(some$, fiasko - 1))
        ELSE
           'PRINT "label slut.. :-("; inst$
           EXIT SUB
        END IF
     END IF
    
     skit$ = some$ + ","
     parcnt = 0: ParamErr = 0
    
     FOR a = 1 TO 4
         Parameter$(a) = ""
     NEXT a
    
     DO
        tmp = INSTR(skit$, ",")
        utklippt$ = MID$(skit$, 1, tmp - 1)
        skit$ = MID$(skit$, tmp + 1)
        parcnt = parcnt + 1
        Parameter$(parcnt) = LTRIM$(utklippt$)
     LOOP WHILE INSTR(skit$, ",") <> 0
     
     IF RIGHT$(utklippt$, 1) = ")" THEN
        ttt = LEN(utklippt$)
        nytt$ = LEFT$(utklippt$, ttt - 1)
        ful = INSTR(nytt$, "(")
        IF ful > 0 THEN
           del1$ = LEFT$(nytt$, ful - 1)
           del2$ = MID$(nytt$, ful + 1)
           Parameter$(parcnt) = del2$
           parcnt = parcnt + 1
           Parameter$(parcnt) = LTRIM$(del1$)
        ELSE
           PRINT " ("; rad$; ") Missing ("
        END IF
     END IF

     ParameterCNT = parcnt
     IF trams < ParameterCNT THEN
        tmp$ = LTRIM$(STR$(ParameterCNT)) + " found," + STR$(trams) + " needed"
        ErrorCode 5, tmp$: ParamErr = 1
     END IF
     IF trams > ParameterCNT THEN
        tmp$ = LTRIM$(STR$(ParameterCNT)) + " found," + STR$(trams) + " needed"
        ErrorCode 6, tmp$: ParamErr = 1
     END IF

END SUB

FUNCTION ToBin16$ (word&)

   numb& = word&
   svar$ = "": cnt# = 65536 / 2
  
   FOR a = 0 TO 15
       tmp# = numb& - cnt#
       IF tmp# >= 0 THEN
          svar$ = svar$ + "1"
          numb& = tmp#
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt# = cnt# / 2
   NEXT
   ToBin16 = svar$

END FUNCTION

FUNCTION ToBin32$ (word&)

   numb& = word&
   svar$ = "": cnt# = 2 ^ 31
 
   FOR a = 0 TO 31
       tmp# = numb& - cnt#
       IF tmp# >= 0 THEN
          svar$ = svar$ + "1"
          numb& = tmp#
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt# = cnt# / 2
   NEXT
   ToBin32 = svar$

END FUNCTION

FUNCTION ToBin8$ (byte&)
  
   numb = byte&
   svar$ = "": cnt = 128

   FOR a = 0 TO 7
       tmp = numb - cnt
       IF tmp >= 0 THEN
          svar$ = svar$ + "1"
          numb = tmp
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt = cnt / 2
   NEXT
   ToBin8 = svar$

END FUNCTION

SUB Type0
   
    opcode$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0): known = 1
    PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4

END SUB

SUB Type1 (xxx$)

    'Type 1 = addiu rs,rt,imm          '1,2,3
    '       = cache op, offset(base)   '3,1,2

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(2)) + ValidReg(Parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(Parameter$(3))

       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type10 (xxx$)

    'Type 10 = beq reg,reg,offset

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(1)) + ValidReg(Parameter$(2))

       value& = GetAdr(Parameter$(3))
       BranchVal$ = GetBranchVal(value&)
       
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type11 (xxx$)

    'Type 11 = blez rs, offset

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(1)) + "00000"

       value = GetAdr(Parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
    
END SUB

SUB Type12 (xxx$)
   
    'Type 12 = mfc0 rt, fs   (COP0)
  
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010000" + xxx$ + ValidReg(Parameter$(1))
       tmpYY$ = ValidFReg(Parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type13 (xxx$)
   
    'Type 13 = ERET, TLBR etc..
    
    known = 1
    
    tmpXX$ = "010000" + "0" + "000000000"
    tmpYY$ = "0000000000" + xxx$
    opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
    PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4

END SUB

SUB Type14 (xxx$)

    'Type 14 = mtc1 rt, fs     (COP1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + xxx$ + ValidReg(Parameter$(1))
       tmpYY$ = ValidFReg(Parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type15 (xxx$)

    'Type 15 = mfc2 rt, fs      (COP2)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010010" + xxx$ + ValidReg(Parameter$(1))
       tmpYY$ = ValidCP2Reg(Parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type16 (xxx$)

    'Type 16 = BC0F offset  (COP0)
 
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010000" + "01000" + "000" + xxx$
       tmpYY$ = FixVal16(Parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type17 (xxx$)
   
    'Type 17 = BC1F offset  (COP1)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "01000" + "000" + xxx$

       value& = GetAdr(Parameter$(1))
       BranchVal$ = GetBranchVal(value&)
       
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type18 (xxx$)
   
    'Type 18 = sync
  
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "0000000000"
       tmpYY$ = "00000" + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type19 (xxx$)
   
    'Type 19 = jalr rs, rd
 
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(Parameter$(1)) + "00000"
       tmpYY$ = ValidReg(Parameter$(2)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
    
END SUB

SUB Type2 (xxx$)

    'Type 2 = lui rt, immediate

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       opcode$ = CHR$(FromBin(xxx$ + "00")) + CHR$(FromBin("000" + ValidReg(Parameter$(1)))) + FixVal16(Parameter$(2))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type20 (xxx$)
   
    'Type 20 = add.s  (SINGLE!) (cop1)
 
    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + ValidFReg(Parameter$(3))
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type21 (xxx$)
   
    'Type 21 = add.d  (DOUBLE!) (cop1)

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + ValidFReg(Parameter$(3))
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type22 (xxx$)
   
    'Type 22 = abs.s  (SINGLE!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + "00000"
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type23 (xxx$)
   
    'Type 23 = abs.d  (double!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + "00000"
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type24 (xxx$)
   
    'Type 24 = cvt.s.w  (word!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10100" + "00000"
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type25 (xxx$)
   
    'Type 25 = cvt.s.l  (long!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10101" + "00000"
       tmpYY$ = ValidFReg(Parameter$(2)) + ValidFReg(Parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type26 (xxx$)
   
    'Type 26 = BC2F offset  (COP2)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010010" + "01000" + "000" + xxx$
       tmpYY$ = FixVal16(Parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type27 (xxx$)

    'Type 27 = C.cond.S (single!) COP1

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + ValidFReg(Parameter$(2))
       tmpYY$ = ValidFReg(Parameter$(1)) + "000" + "0011" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type28 (xxx$)
   
    'Type 28 = C.cond.D (double!) COP1

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + ValidFReg(Parameter$(2))
       tmpYY$ = ValidFReg(Parameter$(1)) + "000" + "0011" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type29 (xxx$)

    'Type 29 = tge rs, rt
 
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(Parameter$(1)) + ValidReg(Parameter$(2))
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type3 (xxx$)

    'Type 3 = srav rd, rt, rs

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(Parameter$(2)) + ValidReg(Parameter$(3))
       tmpYY$ = ValidReg(Parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type30 (xxx$)
   
    'Type 30 = break offset    (20 bits)

    SplitParam param$, 1: known = 1
    IF Parameter$(1) <> "" THEN
       IF ParamErr = 0 THEN
          value& = GetAdr(Parameter$(1))
          BranchVal$ = GetBranchValBREAK(value&)
         
          tmp11$ = "000000" + BranchVal$ + xxx$
          tmpXX$ = LEFT$(tmp11$, 16)
          tmpYY$ = RIGHT$(tmp11$, 16)
         
          opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
          PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
       END IF
    ELSE
       tmp11$ = "000000" + STRING$(20, "0") + xxx$
       tmpXX$ = LEFT$(tmp11$, 16)
       tmpYY$ = RIGHT$(tmp11$, 16)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type31 (xxx$)

    'Type 31 = teqi rs, immediate
  
  
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000001" + ValidReg(Parameter$(1)) + xxx$

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(Parameter$(2))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type32 (xxx$)

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(Parameter$(2)) + ValidFReg(Parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(Parameter$(3))

       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type4 (xxx$)

    'Type 4 = sll rd, rt, sa

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       ToBin5$ = RIGHT$(ToBin8(VAL(GetValue16(Parameter$(3)))), 5)

       tmpXX$ = "000000" + "00000" + ValidReg(Parameter$(2))
       tmpYY$ = ValidReg(Parameter$(1)) + ToBin5$ + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type5 (xxx$)

    'Type 5 = mult rs, rt
   
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(Parameter$(1)) + ValidReg(Parameter$(2))
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type6 (xxx$)

    'Type 6 = mfhi rd
   
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "0000000000000000"
       tmpYY$ = ValidReg(Parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type7 (xxx$)

    'Type 7 = mthi rs
   
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(Parameter$(1)) + "00000"
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type8 (xxx$)

    'Type 8 = J target, JAL target

    SplitParam param$, 1: known = 1

    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00"
       value& = GetAdr(Parameter$(1))

       IF DirectJump = 0 THEN
          flurp& = ((BaseAdr& - &H80000000) / 4) + value&
       ELSE
          flurp& = (value& * 4) / &H10
       END IF
       DirectJump = 0


       IF flurp& < 0 THEN
          blur$ = "11"
          blur2$ = "FFFFFF"
       ELSE
          blur$ = "00"
          blur2$ = "000000"
       END IF
       bra$ = blur2$ + HEX$(flurp&)
       bra$ = RIGHT$(bra$, 6)

       bra1$ = MID$(bra$, 1, 2)
       bra2$ = MID$(bra$, 3, 2)
       bra3$ = MID$(bra$, 5, 2)

       opcode$ = CHR$(FromBin(xxx$ + blur$)) + CHR$(VAL("&h" + bra1$)) + CHR$(VAL("&h" + bra2$)) + CHR$(VAL("&h" + bra3$))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
    
END SUB

SUB Type9 (xxx$)

    'Type 9 = bltz rs, offset
    'buggy

   
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000001" + ValidReg(Parameter$(1)) + xxx$
      
       value& = GetAdr(Parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

FUNCTION ValidCP2Reg$ (txt$)
  
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))

    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
      hittad& = -1
      FOR a = 0 TO 31
          IF LCASE$(CP2Reg$(a)) = txt$ THEN
             hittad& = a
             EXIT FOR
          END IF
      NEXT a
    END IF
     
    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidCP2Reg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF
    

END FUNCTION

FUNCTION ValidFReg$ (txt$)
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))

    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
      hittad& = -1
      FOR a = 0 TO 31
          IF LCASE$(FReg$(a)) = txt$ THEN
             hittad& = a
             EXIT FOR
          END IF
      NEXT a
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(FReg2$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(CP2Reg$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(CP2BReg$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
    END IF
   
    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidFReg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF

END FUNCTION

FUNCTION ValidReg$ (txt$)
   
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))


    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
       hittad& = -1
       FOR a = 0 TO 31
           IF LCASE$(Reg$(a)) = txt$ THEN
              hittad& = a
              EXIT FOR
           END IF
       NEXT a
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg2$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg3$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg4$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          IF txt$ = "zero" THEN hittad& = 0
          IF txt$ = "rzero" THEN hittad& = 0
       END IF
    END IF

    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidReg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF


END FUNCTION

FUNCTION ValidRSPReg$ (txt$)

    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))
    
    IF LEFT$(txt$, 1) = "$" THEN txt$ = MID$(txt$, 2)

    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
      hittad& = -1
      FOR a = 0 TO 31
          IF LCASE$(RSPReg$(a)) = txt$ THEN
             hittad& = a
             EXIT FOR
          END IF
      NEXT a
    END IF

    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidRSPReg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF

END FUNCTION

SUB WordBlock
    paramcnt = 0
    FOR a = 1 TO LEN(param$)
        jos$ = MID$(param$, a, 1)
        IF jos$ = "," THEN paramcnt = paramcnt + 1
    NEXT a
   
    SplitParam param$, paramcnt + 1: known = 1
    
    IF ParamErr = 0 THEN
       FOR a = 1 TO paramcnt + 1  'dumpar varje dword
           opcode$ = GetVal32(Parameter$(a))
           opcode$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + opcode$
           opcode$ = RIGHT$(opcode$, 4)
           PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
       NEXT a
    END IF
END SUB

